;======================== header ===============================================
;		2012 Dec 12, KB, update to final SoFAST version 
;======================== end header ===========================================
PRO sofast ; 04072013 _swaplocal, begindate=begindate, enddate=enddate, toplevdir=toplevdir, goes_spacecraft=goes_spacecraft, archive=archive 

; e.g. begindate ='2011-02-18' and enddate='2011-02-20'
; KB: toplevdir = '/Users/katrien/PROBA2/variabiliteit_analyse/DATA/'
; sofast_swaplocal, begindate='2011-03-08', enddate='2011-03-08', toplevdir='/Users/katrien/PROBA2/variabiliteit_analyse/DATA/', goes_spacecraft='go15', /archive ; as from nov 2010 data comes from goes15 (latest GOES spacecraft).
; sofast_swaplocal, begindate='2010-11-17', enddate='2010-11-17', toplevdir='/Users/p2sc_ops/software/SoFAST/', goes_spacecraft='go15', /archive
;
; !! AS FROM 01092010 (or 01112010 - dze margin) go15 is active, before that use 'go14' !!
;
; !! Most easy working: Make sure GOES EVENT FILES OLDER THAN 2 MONTHS FROM RUNTIME ARE IN "GOESDIR" !!
; !! The necessary zip files with event files can be found at http://www.swpc.noaa.gov/ftpdir/warehouse/ !!
;

; this is sofast to run local with keywords
; toplevdir at azrael = /home/sol/sofast
; local toplevdir='/Users/katrien/PROBA2/variabiliteit_analyse/DATA/'


;--------------------------------------------------------------------------
; SETTINGS DEPENDING SERVER WHERE WE RUN SoFAST
   getGOESASCIIdata = 1    ; if set to 1, we will get the latest GOES ASCII data ; FOR REALTIME (most update, only +-4 months in the past)
   getGOESFITSdata = 0    ; if set to 1, we will get the latest GOES FITS data ; FOR ARCHIVE (most complete in the past)
   getGOESLOCALdata = 0    ; if set to 1, we will read local GOES fits files
   sol055 = 0 ; 1 for sol055 concerning color tables and other settings
   azrael = 1 ; 01042013 (DB)
   local = 0

;--------------------------------------------------------------------------
IF azrael eq 1 THEN BEGIN

	toplevdir='/home/sofast/sofast/'
	goes_spacecraft='go15'
        ; today 
           days_ago=0 ; k
           caldat, systime(/julian)-days_ago, month, day, year
           enddate= strtrim(year,2)+'-'+strmid(strtrim(100+month,2),1,2)+'-'+strmid(strtrim(100+day,2),1,2)

        ; yesterday
           days_ago=9 ; k+XXXX
           caldat, systime(/julian)-days_ago, month, day, year
           begindate= strtrim(year,2)+'-'+strmid(strtrim(100+month,2),1,2)+'-'+strmid(strtrim(100+day,2),1,2)
ENDIF

;--------------------------------------------------------------------------
; START
mystart=systime()
		
runStart_jul = systime(/julian)
runStart = string(runStart_jul,format="(C(CYI4.4,'-',CMOI2.2,'-',CDI2.2,' ',CHI2.2,':',CMI2.2,':',CSI2.2))") ; 2013-02-01 12:45:00 

;--------------------------------------------------------------------------
; FREE PARAMETERS 
; the requested time difference range and tolerance (in minutes)
 	timedif  =  60l * 12l   ; we want image pairs that are 12 minutes apart, EIT forever!  (expressed in seconds)
 	timetol  =  120l * 1l    ; we accept a tolerance of 2 minutes ; 120 seconds 
; the dimension of the rebinned images
	rebinsize	= 	16 ; can best be even number (not odd)
; the threshold on which to trigger (arbitraty scale 0-5)
	threshold	= 1 ;50 ;0.5 ;13000 ; for cleaning eventmovie: if more than 'maxhits' values of 'gt threshold', than particle storm ~GOOD ; orig threshold = 2
; the minimal and maximal number of hits required to trigger
	minhits		= 	1 ; orig minhits = 1 (one macropixel in an image is fine for an event, actually I don't use it so far)
	maxhits		=	4 ; orig maxhits = 18   IF MORE THAN 4 MACROPIXELS HAVE VALUE 2 OR HIGHER (~GT THRESHOLD) THAN COSMIC STORMED
; the minimal flare amplitude (arbitrary scale 0-5)
	min_flare_peak	=	2 ;2 ;5 ;250 ;3 ;35000 ; orig min_flare_peak = 10 (+cluster 9)
	min_cluster_peak  = 1 ;1 ;3 ;230 ;2.9 ;33000
; min # images that region should cover	
	min_lifetime_region = 4


; instrumental
	xres=1024
	yres=1024
	
	xwidth=xres/rebinsize
	ywidth=yres/rebinsize
	
	offset = 65 ; cfr. histogram, most interesting intensity is between 150 and 400.  Subtracting offset after difference a-b results in interesting value >65

; FOR REALTIME OUTPUT (distinguish events with significance above and below 8%)
	sign_threshold = 8
	eclipse_notification = '  '
	first_SWAP_thisrun_final = 'n.a.'
	last_SWAP_thisrun_final = 'n.a.'
	
	nr_events = 0					; startvalue
    totalNr_images = 0			; startvalue
    nr_good_images = 0			; startvalue

	
;--------------------------------------------------------------------------

;main directories ===============================================================================================

IF azrael eq 1 THEN BEGIN
	tempdir = toplevdir+'temp/'   ; to put intermediate files
ENDIF ELSE BEGIN
   	tempdir = toplevdir+'temp_swaplocal/'   ; to put intermediate files
ENDELSE

   outdim = 800 ; output size
   scale=(outdim/1024.)
   

; secondary directories =========================================================================================
   
   IF sol055 eq 1 THEN BEGIN
   		swap_inputdir = toplevdir+'../../data/swap/level1/'
   ENDIF ELSE BEGIN
   		swap_inputdir = tempdir+'input/'
   ENDELSE
   
   inputdir     	= tempdir+'input/'
              		; directory where input files are stored
   outwwwdir    	= tempdir+'images/'
              		; directory where images are stored for uploading
   savdir			= tempdir+'sav/'
			 		; directory where sav files are stored
   historysavdir 	= savdir+'history/'
					; directory where sav files are "archived"
   eventdir			= tempdir+'events/'
   goesfitsdir		= 'GOESFITS/' ;'./'
   goesdir			= inputdir+goesfitsdir ; e.g. inputdir+'GOESFITS/'
   goeseventdir		= inputdir+'GOESEVENTS/'
   goesasciidir		= inputdir+'GOESASCII/'
   
   IF azrael eq 1 THEN BEGIN
   		archivedir		= toplevdir+'SoFAST/ARCHIVE/'
   		latestEventdir	= '/home/sofast/homepage/latestEvents/'
   ENDIF ELSE BEGIN
   		archivedir		= toplevdir+'SoFAST_swaplocal/ARCHIVE/'
   		latestEventdir	= toplevdir+'SoFAST_swaplocal/latestEvents/'
   ENDELSE
   
;   listdir			= toplevdir+'SoFAST/ARCHIVE/SoFAST_eventlists_txt/'    ;%%%%%%%
;   listdir_latestEvents = toplevdir+'SoFAST_swaplocal/latestEvents/SoFAST_LatestEvents_eventlists_txt/' 

   IF azrael eq 1 THEN BEGIN
   		source = 'web'   ; %%%%  put source=inputdir if files are local
   ENDIF

;--------------------------------------------------------------------------

;DAB20130709 journal, tempdir+'sofast_script_log.txt'
print, " >>> mystart ="+mystart+">>>>>>>>>>>>>>>>>>>>>>>"

spawn, 'rm -rf '+eventdir+'*'

spawn, 'rm -rf '+outwwwdir+'EUVflare_000*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_001*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_002*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_003*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_004*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_005*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_006*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_007*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_008*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_009*'
spawn, 'rm -rf '+outwwwdir+'temp_000*'
spawn, 'rm -rf '+outwwwdir+'temp_001*'
spawn, 'rm -rf '+outwwwdir+'temp_002*'
spawn, 'rm -rf '+outwwwdir+'temp_003*'
spawn, 'rm -rf '+outwwwdir+'temp_004*'
spawn, 'rm -rf '+outwwwdir+'temp_005*'
spawn, 'rm -rf '+outwwwdir+'temp_006*'
spawn, 'rm -rf '+outwwwdir+'temp_007*'
spawn, 'rm -rf '+outwwwdir+'temp_008*'
spawn, 'rm -rf '+outwwwdir+'temp_009*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_000*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_001*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_002*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_003*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_004*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_005*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_006*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_007*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_008*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_009*'
spawn, 'rm -rf '+outwwwdir+'*'

spawn, 'rm -rf '+savdir+'blur_*'
spawn, 'rm -rf '+savdir+'euvflare*'
spawn, 'rm -rf '+savdir+'macropixel_*'
spawn, 'rm -rf '+savdir+'plot_*'
spawn, 'rm -rf '+savdir+'regions*'
spawn, 'rm -rf '+savdir+'timeline_maxima*'
spawn, 'rm -rf '+savdir+'timeline_minima*'
spawn, 'rm -rf '+savdir+'*'

IF azrael eq 1 THEN BEGIN
	spawn, 'rm -rf '+inputdir+'20**/*' 
ENDIF

;--------------------------------------------------------------------------

; CREATING SoFAST_INSTRUMENT STRUCTURE FOR DATABASE
template_02= {$
		instrument:'SWAP', $   							; 'SWAPlike'
		detector: 'SWAP' , $  							; 'SWAPlike'
		xPixels: xres , $									; 0l
		yPixels: yres } 									; 0l
sofast_instruments = template_02

save, filename=eventdir+'STR_sofast_instruments.sav', sofast_instruments

;--------------------------------------------------------------------------

; get SWAP files ONLINE or LOCALLY and create stucture of ALL images from begindate to enddate (im_list = array of structures) =========
print, '    '
print, ">> started sofast_p2_getswapfilenames at "+systime()
print, '    '
IF azrael eq 1 THEN BEGIN
	; get files and create stucture of ALL images from begindate to enddate (im_list = array of structures) =========
	allfiles = sofast_p2_getswapfilenames (begindate, enddate, source=source, savdir=savdir)   ; %%% source= web
	; IF source eq 'web' THEN BEGIN
	        for i=0, n_elements(allfiles)-1 do begin
	                daydir=inputdir+strjoin(strsplit(allfiles[i].date,/extract, '-'),'/')+'/'
	                file_mkdir, daydir  ; make the directory if it does not exist yet
	                cd, daydir          ; go there 
	                sock_copy, allfiles[i].url       ; effectively download the file
	        endfor
	        ; get the filenames again but now local
	        allfiles = sofast_p2_getswapfilenames (begindate, enddate, source=inputdir, savdir=savdir)  	
	; ENDIF
ENDIF ELSE BEGIN
	allfiles = sofast_p2_getswapfilenames(begindate, enddate, source=swap_inputdir, savdir=savdir)
ENDELSE
   
;--------------------------------------------------------------------------

; READ FILES and make array for diff movie (images minus +- 12 minutes before image) ============================
print, '    '
print, ">> started sofast_make_eventmovie at "+systime()
print, '    '
eventmovie = sofast_make_eventmovie(begindate=begindate, enddate=enddate, allfiles=allfiles, savdir=savdir, eventdir=eventdir, timedif=timedif, timetol=timetol, rebinsize=rebinsize, xwidth=xwidth, ywidth=ywidth, offset=offset, first_SWAP_thisrun_final=first_SWAP_thisrun_final, last_SWAP_thisrun_final=last_SWAP_thisrun_final, eclipse_notification=eclipse_notification, totalNr_images=totalNr_images, nr_good_images=nr_good_images)		
; Note: dividing by 2b removed!!  
; Eventmovie = array of 12min-differences of rebinned 16x16 images 													
; Value zero where no sister or blurred sister.																		
; Value zero where blurred.
; Values 0-255


IF eclipse_notification eq '  ' THEN BEGIN
	eclipse_note = 'no'
ENDIF ELSE BEGIN
	eclipse_note = 'yes'
ENDELSE

;--------------------------------------------------------------------------

; CREATING SoFAST_RUN STRUCTURE FOR DATABASE

template_03= {$
		data: 'swapdata_ok', $								; if no data this will be changed to no_swapdata
		triggerThreshold: threshold, $ 						; 0.0
		rebinSize: rebinsize, $        						; 0l
		timeDif: timedif , $								; 0l
		maxHits: maxhits,$          						; 0l
		minHits: minhits, $ 								; 0l
		offset: offset, $									; 0l
		modus: 'Space Weather Service - SoFAST v1.2.0', $  
		timeTol: timetol, $ ; in seconds (120l)				; 0l
		minFlarePeak: min_flare_peak, $  					; 0.0
		minClusterPeak: min_cluster_peak, $  				; 0.0
		minLifetimeRegion: min_lifetime_region, $  			; 0l
		significanceThreshold: sign_threshold, $			; 0.0
		runStarttime: runStart, $							; '2010-10-10 00:00:00'
		begindate: begindate, $								; '2011-01-01'
		enddate: enddate, $									; '2011-12-31'
		nr_events: nr_events, $									; to be defined after run
		totalNr_images: totalNr_images, $						; to be defined after run
		nr_good_images: nr_good_images, $						; to be defined after run
		eclipseNotification: eclipse_note} 					; to be defined after run
sofast_run = template_03

;--------------------------------------------------------------------------
	
; CLEAN EVENTMOVIE from cosmic storms and detect regions over time ==============================================

IF n_elements(allfiles) gt 1 THEN BEGIN
	print, '    '
	print, ">> started sofast_eventmovie_cleaner at "+systime()
	print, '    '
	regions = sofast_eventmovie_cleaner (eventmovie=eventmovie, savdir=savdir, allfiles=allfiles, eventdir=eventdir, rebinsize=rebinsize, threshold=threshold, maxhits=maxhits, minhits=minhits, min_flare_peak=min_flare_peak, min_cluster_peak=min_cluster_peak, min_lifetime_region=min_lifetime_region, nr_events=nr_events) ; allfiles ~ im_list (array of structures)
		; stop																				   
		; regions = array over time 16x16 containing region numbers
	sofast_run.nr_events = nr_events

ENDIF ELSE BEGIN
	regions = eventmovie*0b
	files=allfiles
	save, filename=savdir+'regions.sav', files, eventmovie, regions
	sofast_run.data = 'no_swapdata'
	sofast_run.nr_events = 0
ENDELSE

save, filename=eventdir+'STR_sofast_run.sav', sofast_run

; NOTE: blurred images are up to a certain level filtered out from level0 to level1 (in advance).  We suppose they will be additionally filtered out by working with upper threshold maxhits.  Also recall we take diff images (12min) and we work with macropixels...

; PLOT REGIONS + print SWAP detection list ======================================================================
print, '    '
print, ">> started sofast_region_plotter at "+systime()
print, '    '
sofast_region_plotter, begindate=begindate, enddate=enddate, savdir=savdir, eventdir=eventdir, outwwwdir=outwwwdir, goesdir=goesdir, goeseventdir=goeseventdir, goesasciidir=goesasciidir, latestEventdir=latestEventdir, goes_spacecraft=goes_spacecraft, inputdir=inputdir, GOESsav=GOESsav, rebinsize=rebinsize, xwidth=xwidth, ywidth=ywidth, xres=xres, yres=yres, min_flare_peak=min_flare_peak, min_cluster_peak=min_cluster_peak, offset=offset, sign_threshold=sign_threshold, first_SWAP_thisrun_final=first_SWAP_thisrun_final, last_SWAP_thisrun_final=last_SWAP_thisrun_final, getGOESASCIIdata=getGOESASCIIdata, getGOESFITSdata=getGOESFITSdata, getGOESLOCALdata=getGOESLOCALdata, /crontab, eclipse_notification=eclipse_notification, archive=archive, sol055=sol055  
; local (online getGOESASCIIdata=1 en /crontab implies no windowing on screen)
; stop


myend=systime()

print, 'mystart = ', mystart
print, 'myend = ', myend
myend_string = str_replace(str_replace(myend, ':', '_'), ' ', '-')


IF azrael eq 1 THEN BEGIN
	spawn, 'cp '+toplevdir+'insertMov.js '+eventdir
	spawn, 'cp '+toplevdir+'sofast_struisvogel_paars_60.jpg '+eventdir
	spawn, 'cp '+toplevdir+'styles.css '+eventdir
	spawn, 'cp '+toplevdir+'sofast_ThisRun_Movie.html '+eventdir
ENDIF ELSE BEGIN
	spawn, 'cp '+inputdir+'insertMov.js '+eventdir 
	spawn, 'cp '+inputdir+'sofast_struisvogel_paars_60.jpg '+eventdir 
	spawn, 'cp '+inputdir+'styles.css '+eventdir 
	spawn, 'cp '+inputdir+'sofast_ThisRun_Movie.html '+eventdir 
ENDELSE

IF keyword_set(archive) THEN BEGIN
	spawn, 'mkdir '+archivedir+'SoFAST_events_BEGIN='+begindate+'_END='+enddate+'_RUN_was_'+strtrim(myend_string,2)+'/'
	spawn, 'cp -rf '+eventdir+'* '+archivedir+'SoFAST_events_BEGIN='+begindate+'_END='+enddate+'_RUN_was_'+strtrim(myend_string,2)
	listdir = archivedir+'SoFAST_eventlists_TXTfiles_BEGIN='+begindate+'_END='+enddate+'_RUN_was_'+strtrim(myend_string,2)+'/'
	spawn, 'mkdir '+listdir
	spawn, 'cp -rf '+eventdir+'*.txt '+listdir
	
	; IF sol055 eq 1 THEN BEGIN and IF azrael eq 1 and if local eq 1....  = always ;-))
		;OPENW, lun1, tempdir+'sofast_script_log.txt', /get_lun, width=200, /append
		;printf, lun1, " <<< finalizing sofast_script at "+systime()+"<<<<<<<<<<<<<<<<<<<<<<"
		;CLOSE, lun1		
		;FREE_LUN, lun1
		print, ' <<< finalizing sofast_script at '+systime()+'<<<<<<<<<<<<<<<<<<<<<<'
		;DAB20130709 journal
		spawn, 'mv '+tempdir+'sofast_script_log.txt '+archivedir+'SoFAST_events_BEGIN='+begindate+'_END='+enddate+'_RUN_was_'+strtrim(myend_string,2)+'/sofast_script_log.txt'
	; ENDIF

ENDIF ELSE BEGIN ; ENDIF keyword_set(archive) THEN BEGIN
	spawn, 'rm -rf '+latestEventdir+'*'
	spawn, 'cp -rf '+eventdir+'* '+latestEventdir
	listdir_latestEvents = latestEventdir+'SoFAST_LatestEvents_eventlists_txt/' 
	spawn, 'mkdir '+listdir_latestEvents
	spawn, 'cp -rf '+eventdir+'*.txt '+listdir_latestEvents
	
	; IF sol055 eq 1 THEN BEGIN and IF azrael eq 1 and if local eq 1....  = always ;-))
		;OPENW, lun1, tempdir+'sofast_script_log.txt', /get_lun, width=200, /append
		;printf, lun1, " <<< finalizing sofast_script at "+systime()+"<<<<<<<<<<<<<<<<<<<<<<"
		;CLOSE, lun1		
		;FREE_LUN, lun1
		print, ' <<< finalizing sofast_script at '+systime()+'<<<<<<<<<<<<<<<<<<<<<<'
		;DAB20130709  journal
		spawn, 'mv '+tempdir+'sofast_script_log.txt '+latestEventdir+'sofast_script_log.txt'
	; ENDIF

ENDELSE

; stop

spawn, 'rm -rf '+eventdir+'*'

spawn, 'rm -rf '+outwwwdir+'EUVflare_000*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_001*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_002*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_003*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_004*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_005*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_006*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_007*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_008*'
spawn, 'rm -rf '+outwwwdir+'EUVflare_009*'
spawn, 'rm -rf '+outwwwdir+'temp_000*'
spawn, 'rm -rf '+outwwwdir+'temp_001*'
spawn, 'rm -rf '+outwwwdir+'temp_002*'
spawn, 'rm -rf '+outwwwdir+'temp_003*'
spawn, 'rm -rf '+outwwwdir+'temp_004*'
spawn, 'rm -rf '+outwwwdir+'temp_005*'
spawn, 'rm -rf '+outwwwdir+'temp_006*'
spawn, 'rm -rf '+outwwwdir+'temp_007*'
spawn, 'rm -rf '+outwwwdir+'temp_008*'
spawn, 'rm -rf '+outwwwdir+'temp_009*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_000*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_001*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_002*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_003*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_004*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_005*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_006*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_007*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_008*'
spawn, 'rm -rf '+outwwwdir+'Thisrun_Win11_009*'
spawn, 'rm -rf '+outwwwdir+'*'

spawn, 'rm -rf '+savdir+'blur_*'
spawn, 'rm -rf '+savdir+'euvflare*'
spawn, 'rm -rf '+savdir+'macropixel_*'
spawn, 'rm -rf '+savdir+'plot_*'
spawn, 'rm -rf '+savdir+'regions*'
spawn, 'rm -rf '+savdir+'timeline_maxima*'
spawn, 'rm -rf '+savdir+'timeline_minima*'
spawn, 'rm -rf '+savdir+'*'

IF azrael eq 1 THEN BEGIN
	spawn, 'rm -rf '+inputdir+'20**/*' 
ENDIF

; stop

END
