;======================== header ===============================================
;+
; NAME: 
;		SOFAST_INFOLINE
;    
; PURPOSE:
;   	This function reads the indicated flare output structure line and print the infoline in txt or html format.  The output contains a link to the concerning 
;		EUV flare html page.
;
; INPUTS:
;		Is called by sofast_region_plotter
;   	thisflare = flare output structure  
;		eventdir = folder where to save event details in general
;		r=r region number
;
; CALLS:
;   	/
;
; RESTORED SAV-files:
;		/
;
; SAVED SAV-files:
;		/
;
; HISTORY:  
;		2012 Dec 12, KB, update to final SoFAST version 
;
;======================== end header ===========================================

FUNCTION sofast_infoline, thisflare, eventdir=eventdir, r=r ; thisflare = structure
	
  link='  <a href="./'+thisflare.type+'_'+strmid(strtrim(1000+r,2),1,3)+'/FLARE.html" target="_blank" >' 	

  infoline = link+strmid(strtrim(1000+thisflare.nr,2),1,3)+'</a>       | '+$
  	         thisflare.date+' | '+ $
             strmid(thisflare.starttime,0,5)+' | '+$
             strmid(thisflare.endtime,0,5)+' |  '+$
             thisflare.position_HG_Stonyhurst+'  |  '+$
             ;strmid(strtrim(1000+thisflare.maxvalue,2),1,3)+' | '+$
             strmid(strtrim(1000+thisflare.eventsize,2),1,3)+' |   '+$
             strmid(strtrim(1000+thisflare.dt,2),1,3)+'   |      '+$
             strmid(strtrim(1000+round(thisflare.euvSignificance),2),1,3) +' %'

; ENDELSE
 
return, infoline

END
