;======================== header ===============================================
;+
; NAME: 
;		SOFAST_INFOLINE_NOLINK
;    
; PURPOSE:
;		Is called by sofast_flare_html
;   	This function reads the indicated flare output structure line and print the infoline in txt or html format. 
;
; INPUTS:
;   	thisflare = flare output structure  
;		eventdir = folder where to save event details in general
;		r=r region number
;
; CALLS:
;   	/
;
; RESTORED SAV-files:
;		/
;
; SAVED SAV-files:
;		/
;
; HISTORY:  
;		2012 Dec 12, KB, update to final SoFAST version 
;
;======================== end header ===========================================

FUNCTION sofast_infoline_nolink, thisflare, eventdir=eventdir, r=r ; thisflare = structure
	
  infoline_nolink = '  '+strmid(strtrim(1000+thisflare.nr,2),1,3)+'       | '+$
  	         thisflare.date+' | '+ $
             strmid(thisflare.starttime,0,5)+' | '+$
             strmid(thisflare.endtime,0,5)+' |  '+$
             thisflare.position_HG_Stonyhurst+'  |  '+$
             ;strmid(strtrim(1000+thisflare.maxvalue,2),1,3)+' | '+$
             strmid(strtrim(1000+thisflare.eventsize,2),1,3)+' |   '+$
             strmid(strtrim(1000+thisflare.dt,2),1,3)+'   |      '+$
             strmid(strtrim(1000+round(thisflare.euvSignificance),2),1,3) +' %'
 
return, infoline_nolink

END
