;======================== header ===============================================
;+
; NAME:
;       SOFAST_REGION_PLOTTER
;
; !! Most easy working: Make sure GOES EVENT FILES OLDER THAN 2 MONTHS FROM RUNTIME ARE IN "GOESEVENTS DIR" !!
; !! The necessary zip files with event files can be found at http://www.swpc.noaa.gov/ftpdir/warehouse/ !!
;
;
; PURPOSE:
;		Is called by sofast.pro  (or sofast_swaplocal.pro or sofast_WGET_local.pro)
;       In general: Creates plots and movies for the SoFAST output.
; 		GETS GOES EVENTS and SAVE IN STRUCTURE GOESFLARES (sofast_p2_get_goes_flares)
; 		START CREATING SoFAST MAIN OUTPUT WEBPAGE (sofast_main_html)
; 		PLOTTING ALOG SWAP IMAGE WITH INDICATED DETECTED REGIONS, FOR EACH TIME STEP (SWAP CADENCE) FOR CREATING OVERVIEW MOVIE OF RUN (Win11) 
; 		INITIALISING PARAMETERS AND FLARE-STRUCTURE (for database output)
; 		OBTAINING ALL OBSERVATION INFO PER EVENT (region) LOOP OVER R    (starttime, endtime, ...).
			; DEFINE MAXVALUE OF EVENTMOVIE_THISREGION = DEFINE PRINCIPAL MP (+SAVE SNAPSHOT IN TIME OF EVENTMOVIE AT MAXPOS)
			; DEFINE X AND Y OF PRINCIPAL MP, then RESTORE MAX/MIN/INTENSITY MP + CALCULATE MAIN MP STATISTICAL PARAMETERS
			; CHECK IF THE DETECTED REGION CONCERNS A GOES FLARE (update files structure: goesmatch, goesstarttime, goesendtime, goestype, goesNOAAregion..)
			; CALCULATE HELIOGRAPHIC CO-ORDINATES
			; OUTPUT ALL DATA OF THE EVENT (r) TO SoFAST_events_SWAP_begindate.txt FILE in eventdir
			; ENTER ALL VALUES IN THE CREATED FLARE STRUCTURE, FOR THIS FLARE r
			; PLOT MACROPIXEL INTENSITY FOR THIS REGION/EVENT
		; END LOOP OVER ALL EVENTS R
			
		; CHECK WHICH GOES FLARES ARE DETECTED / WHICH MISSED (statistics)	; write this info to SoFAST_missed_eventlist_GOES_detected_'+begindate+'.txt
		
		; MORE PLOTS PER EVENT ~ NEW LOOP OVER ALL EVENTS
			;******************* PLOT 1. eventdir/flaredir/ **_compared_GOES.png *******************
										; READ GOES DATA (adapting location manually with run no longer necessary)	
											; if getGOESASCIIdata
											; if getGOESFITSdata
											; if getGOESLOCALdata	
										; get todays data: 
											; restore, regions (again) = WHEN is this region, WHERE is this region, ....
			
			;******************* PLOT 2. eventdir/ **_Win1.png ******************* ; pre-event (at start-time)
			;******************* UNCOMMENTED: PLOT 3. eventdir/flaredir/ **_Win1.png ******************* ; pre-event (at start-time)
			;******************* PLOT 4. eventdir/flaredir/ img****.png ******************* ; subfield, difference SWAPimage minus SWAPimage_sister
			;******************* PLOT 5. eventdir/flaredir/ sqrt_img****.png ******************* ; subfield, sqrt SWAPimages
			;******************* PLOT 6. eventdir/ ****_plot_eventmovie_thisregion.png ******************* 
 						; plots plot_eventmovie_thisregion = a slice in time of eventmovie_thisregion where maximum value of eventmovie_thisregion occurs	    

 			;******************* CREATE MOVIE 1. eventdir/flaredir/ ****_subfield_diff_images.mp4 *******************
  			;******************* CREATE MOVIE 2. eventdir/flaredir/ ****_subfield_sqrt_images.mp4 ******************* 
 			;******************* CREATE MOVIE 3. eventdir/flaredir/ FLARE.mov ******************* 
			
	 	 	; START PRODUCING AN HTML PAGE PER EVENT (sofast_flare_html)    	 	     	
		; END SECOND LOOP OVER ALL EVENTS R
			
		; TOWARDS MOVIE OVERVIEW ALL DETECTIONS IN ONE IMAGE (overview includes no detection if max(regions)=0 that's OK)
 		;******************* PLOT 7. eventdir/overview_SoFAST_events.png *******************
 		
 		; TOWARDS MOVIE OVERVIEW ALL SWAP IMAGES + INDICATED EVENTS + COMPARED TO GOES 
		;******************* PLOT 8. outwwwdir/ ****_compared_GOES.jpeg *******************
										; READ GOES DATA (adapting location manually with run no longer necessary)	
											; if getGOESASCIIdata
											; if getGOESFITSdata
											; if getGOESLOCALdata	
										; get todays data: 
											; restore, regions (again) = WHEN is this region, WHERE is this region, ....
											
 		; TOWARDS MOVIE 6. (ImageMagick)
 		; OUTPUT ALL INFO TO sofast_out.html = html page with catalogue events 	 	
 		; OUTPUT STATISTICAL INFO OF ALL DETECTIONS COMPARED TO GOES to SoFAST_statistical_overview_'+begindate+'.txt 	 	
		
		;******************* UNCOMMENTED: CREATE MOVIE 4. eventdir/ThisRun_Win1.mp4 ******************* 
 		;******************* UNCOMMENTED: CREATE MOVIE 5. eventdir/GOES_timeline.mp4 ******************* 
 		;******************* CREATE MOVIE 6. eventdir/SoFAST_compared_GOES_timeline.mp4 ******************* 
;
;
; INPUT:
;		begindate=begindate, enddate=enddate
;		savdir=savdir, eventdir=eventdir, outwwwdir=outwwwdir, goesdir=goesdir, inputdir=inputdir
;		goes_spacecraft=goes_spacecraft, GOESsav=GOESsav
;
;		VALUES KNOWN FROM SOFAST.PRO:
;		rebinsize=rebinsize
;		xwidth=xwidth, ywidth=ywidth, xres=xres, yres=yres
;		min_flare_peak=min_flare_peak, min_cluster_peak=min_cluster_peak (thresholds for flare peaks and resp. neighbours when clustering)
;		offset=offset, sign_threshold=sign_threshold
;		first_SWAP_thisrun_final=first_SWAP_thisrun_final, last_SWAP_thisrun_final=last_SWAP_thisrun_final
;		to be saved: eclipse_notification=eclipse_notification
;		keywords: getGOESASCIIdata=getGOESASCIIdata, crontab=crontab
;
; PROCEDURES USED:
;		sofast_p2_get_goes_flares
;		sofast_main_html
;		readfits
;		sofast_headerline
;		sofast_get_GOES_latest_ascii_data
;		sofast_get_goes_fits_data_1day
;		sofast_flare_html
;		sofast_infoline
;
; RESTORED SAV-files:
;		regions.sav (3x)
;		timeline_maxima_thismacropixel_X'+strtrim(x_p,2)+'_Y'+strtrim(y_p,2)+'.sav
;		timeline_minima_thismacropixel_X'+strtrim(x_p,2)+'_Y'+strtrim(y_p,2)+'.sav
;		macropixel_int_X'+strtrim(x_p,2)+'_Y'+strtrim(y_p,2)+'.sav
;		plot_eventmovie_thisregion_'+strmid(strtrim(1000+r,2),1,3)+'.sav
;
; SAVED SAV-files:
;		save, filename = savdir+'plot_eventmovie_thisregion_'+strmid(strtrim(1000+r,2),1,3)+'.sav', plot_eventmovie_thisregion
;		UNCOMMENTED: save, filename = savdir+'thisrun_alldetections_begindate_begintimes_endtimes_HHMMSS.sav', rbegindate, rbegintime, rendtime ; arrays with n_elements = # regions (detections) ; TOWARDS LYRA FLARE AMPLITUDE
;		save, filename=eventdir+'STR_sofast_events.sav', sofast_events ; structure of structure elements, one element per event

;
; HISTORY:  
;		2012 Dec 12, KB, update to final SoFAST version 
;-
;======================== end header ===========================================

pro sofast_region_plotter, begindate=begindate, enddate=enddate, savdir=savdir, eventdir=eventdir, outwwwdir=outwwwdir, goesdir=goesdir, goeseventdir=goeseventdir, goesasciidir=goesasciidir, latestEventdir=latestEventdir, goes_spacecraft=goes_spacecraft, inputdir=inputdir, GOESsav=GOESsav, rebinsize=rebinsize, xwidth=xwidth, ywidth=ywidth, xres=xres, yres=yres, min_flare_peak=min_flare_peak, min_cluster_peak=min_cluster_peak, offset=offset, sign_threshold=sign_threshold, first_SWAP_thisrun_final=first_SWAP_thisrun_final, last_SWAP_thisrun_final=last_SWAP_thisrun_final, getGOESASCIIdata=getGOESASCIIdata, getGOESFITSdata=getGOESFITSdata, getGOESLOCALdata=getGOESLOCALdata, crontab=crontab, eclipse_notification=eclipse_notification, archive=archive, sol055=sol055



restore, savdir+'regions.sav' 	; contains files, eventmovie, regions, sec 
								; REGIONS is 3D array with peak-groups numbered 0 --> max(regions)
								; EVENTMOVIE = 12min-differences of rebinned images being ZERO where cosmicstormed image or sister-image!! values 0-255
								; FILES is structure according to all images (obstime, goesflare covered, ....)
								; SEC is 1D array of obstime each image in sec

IF n_elements(files) le 1 THEN BEGIN ; IF NO SWAP DATA AVAILABLE
	; START CREATING SoFAST MAIN OUTPUT WEBPAGE
	sofast_main_html, eventdir=eventdir, savdir=savdir, first_SWAP_thisrun_final=first_SWAP_thisrun_final, last_SWAP_thisrun_final=last_SWAP_thisrun_final, begindate=begindate
	
	template_01= {$
			nr: 0, $   ; number of event  (0l = long, 2 exp 64)  (0 = int, 2 exp 32)  (0.0 = float) 
			type: 'no_events', $ 		; in case distinction between EUVflare and EUVdyn is required
			date: '2010-10-10' , $         	; observation date yyyy-mm-dd
			starttime: '00:00:00' , $			; HH:MM
			endtime: '23:59:59' ,$   
			macropixel_xpos: 0l, $	; x= 0:15 (rebinsize-1)
			macropixel_ypos: 0l, $	; y= 0:15 (rebinsize-1)		   
			macropixel_xpos_HC: 0.0, $	; heliocentric in arcseconds x= -480:+480 * pres
			macropixel_ypos_HC: 0.0, $	; heliocentric in arcseconds y= -480:+480 * pres	   
			position_HG_Stonyhurst:'W00N00', $	; heliographic Stonyhurst -90:+90
			posN_HG_St:'00', $			; heliographic Stonyhurst
			posS_HG_St: '00', $  			; heliographic Stonyhurst
			posE_HG_St: '00', $ 			; heliographic Stonyhurst
			posW_HG_St: '00', $ 			; heliographic Stonyhurst
			carrLON: 0.0, $				; Carrington Longitude
			maxvalue: 2, $    ; maximum value of eventmovie_thisregion	
			eventsize: 0l, $  ; max number of macropixel spatially involved
			dt: 0l, $  ; number of images in time covering event
			euvSignificance: 0.0}	
		
		sofast_events = template_01
		save, filename=eventdir+'STR_sofast_events.sav', sofast_events ; structure of structure elements, one element per event ;#DAB	

ENDIF ELSE BEGIN ; ENDIF n_elements(files) le 1 THEN BEGIN

	; START CREATING SoFAST MAIN OUTPUT WEBPAGE
	
	sofast_main_html, eventdir=eventdir, savdir=savdir, first_SWAP_thisrun_final=first_SWAP_thisrun_final, last_SWAP_thisrun_final=last_SWAP_thisrun_final, begindate=begindate, /swapdata_ok
	
	; GET GOES EVENTS and SAVE IN STRUCTURE GOESFLARES
	
	goesflares = sofast_p2_get_goes_flares(begindate,enddate, goeseventdir=goeseventdir)  ; OK local = online 
	; !!!! IF NO GOES FLARES: goesflares will be a DUMMY goesflare structure element instead of a valuable structure with actual goes flares
	
	; restore, inputdir+GOESsav ; XXXX2 OK local = online
	; restore, inputdir+'GOESFLARES/GOESflares_01052011_31072011.sav'
	; restore, inputdir+'GOESFLARES/GOESflares_01052011_31072011.sav'  
	
	
	; PLOTTING ALOG SWAP IMAGE WITH INDICATED DETECTED REGIONS, FOR EACH TIME STEP (SWAP CADENCE) FOR CREATING OVERVIEW MOVIE OF RUN (Win11) 	
	
	outdimx=800    
	outdimy=800
	
	IF not keyword_set(crontab) THEN window, 2, xs=outdimx, ys=outdimy ELSE BEGIN
	      		set_plot, 'Z'
	      		device, set_resolution = [outdimx,outdimy]   ; size of image
	      		device, z_buffering    = 0           ; 0 for 2D
	ENDELSE        
	
	; set color table
	device, decomposed=0 
		RED			=indgen(256)
	  	GREEN		=indgen(256)
	 	BLUE 		=indgen(256)
	 	RED[0:5]  	=[0,	0,		0,		255,	255,	255]	      
	 	GREEN[0:5]	=[0,	0,		255,	255,	0,		0]	      
	 	BLUE[0:5] 	=[0,	255,	0,		0,		0,		255]
		; 0=black, 1=blue, 2=green, 3=yellow, 4=red, 5=purple, 255=white
	IF not keyword_set(sol055) THEN BEGIN
		TVLCT,RED,GREEN,BLUE
	ENDIF
		!p.background = 255
			
	
	FOR p = 0, n_elements(files)-1 DO BEGIN
			
		files[p].n_order=strmid(strtrim(1000000+p,2),1,6)
		this_run_moment_p = readfits(files[p].url)  ; i = timestart (we show region on first image where something happens compared to his sister-image)
	
		overlay=bytscl(congrid(alog10(this_run_moment_p>1),800,800), top=249)+6
	
		
		regions_this_moment_p_orig = regions[*,*,p] ; one moment, this 16x16 will contain numbers of region (1,2,3... where region occurs at moment l).
	
		region_positions=where(regions_this_moment_p_orig ne 0, n_regionpos)
		IF n_regionpos gt 0 THEN BEGIN
			regions_this_moment_p_numbers = regions_this_moment_p_orig[region_positions]
			
			FOR s=0, n_regionpos-1 DO BEGIN
				k = regions_this_moment_p_numbers[s]
				rmap_per_event = regions_this_moment_p_orig
				rmap_per_event[where(regions_this_moment_p_orig eq k)] = 1
				rmap_per_event[where(regions_this_moment_p_orig ne k)] = 0
				myregions =  rebin(rmap_per_event, 800, 800, /sample) ; rmap = total(regions eq r,3) ne 0
				contours =  where( dilate(myregions, replicate(1,5,5))-myregions ne 0, ncontours)
			
				IF ncontours ge 1 THEN overlay[contours] = ((k-1) MOD 5)+1 ; r for different color for each region ; 3=yellow, 4=red
			
			ENDFOR ; FOR s=0, n_regionpos-1 do begin
		
		ENDIF ; IF n_regionpos gt 0 then begin
	
	
		tv, overlay
		; tvcircle, 242, 400, 400, color=255, THICK = 2 ; 245 ipv 250 trial and error, based on (800/16) * 5
	
		; WITH EXPLAINING TEXT		
		; xyouts, 50,740, 'EVENT-nr: ', /device, color = 3, charsize = 2
		; xyouts, 50,710, r, /device, color=3, charsize=2 ; 51 --> 45 show date in fits name
		; xyouts, 50,680, 'pre-event (at start-time): ', /device, color = 3, charsize = 2
		Pswap=strpos(files[p].url, 'swap_')
		xyouts, 50,740, strmid(files[p].url,Pswap,45), /device, color=3, charsize=2 ; 51 --> 45 show date in fits name
		; xyouts, 50,70, 'SIGNIFICANCE (% EUV relative variability): ', /device, color = 3, charsize = 2
		; xyouts, 50,40, significance7[r-1], /device, color=3, charsize=2 ; 51 --> 45 show date in fits name
			
		IF not keyword_set(sol055) THEN BEGIN
			tvlct, rcolor, gcolor, bcolor, /get    
	   	ENDIF
	   	a=tvrd()
	   		
	   	;write_png, eventdir+'Thisrun_Win11_'+strmid(strtrim(1000000+files[p].obstime,2),1,6)+'.png', a, rcolor, gcolor, bcolor ; (6 characters HHMMSS)
	
		IF not keyword_set(sol055) THEN BEGIN	
	   		; NEXT IS BECAUSE JPEG LOADS FASTER THAN PNG FOR MOVIES
	   		; this_image=bytscl(a) ; not needed, already -->255
			s=size(a)
			image3d = BYTARR(3, s(1), s(2))
	   		image3d(0, *, *) = rcolor(a)
	  		image3d(1, *, *) = gcolor(a)
	   		image3d(2, *, *) = bcolor(a)
		ENDIF ELSE BEGIN
			; NEXT IS BECAUSE JPEG LOADS FASTER THAN PNG FOR MOVIES
	   		; this_image=bytscl(a) ; not needed, already -->255
			s=size(a)
			image3d = BYTARR(3, s(1), s(2))
	   		image3d(0, *, *) = RED(a)
	  		image3d(1, *, *) = GREEN(a)
	   		image3d(2, *, *) = BLUE(a)
		ENDELSE
		
		write_jpeg, outwwwdir+'Thisrun_Win11_'+files[p].n_order+'.jpeg', image3d, TRUE=1   		
						
	ENDFOR	; FOR p = 0, n_elements(files)-1 do begin
	
	; END OF PLOTTING ALOG SWAP IMAGE WITH INDICATED DETECTED REGIONS, FOR EACH TIME STEP (SWAP CADENCE) FOR CREATING OVERVIEW MOVIE OF RUN (Win11) 
	
		
	
	; INITIALISING PARAMETERS AND FLARE-STRUCTURE (for database output)
		
	IF max(regions) gt 0 THEN BEGIN
		detections_not_GOES = indgen(max(regions))+1 ; [1,2,3,4,...max(regions)]
		
	ENDIF ELSE BEGIN 
		detections_not_GOES = 0
	ENDELSE
		
	rbegindate=strarr(max(regions)+1) 	; array of dim #regions+1, 
										;containing empty strings (+1 since we will make region1 correspond with position 1 not position 0)
	renddate=strarr(max(regions)+1)
	rbegintime=strarr(max(regions)+1)
	rendtime=strarr(max(regions)+1)
		
	;r_starthour=strarr(max(regions)+1)
	;hours= (files.obstime_n - files.date_n*86400l)/(60.*60.) ; DB
		
	n_missed_GOES_events = 0
	n_matched_GOES_events = 0
	n_matched_GOES_Xflares = 0
	n_missed_GOES_Xflares = 0
	n_matched_GOES_Mflares = 0
	n_missed_GOES_Mflares = 0
	n_matched_GOES_Cflares = 0
	n_missed_GOES_Cflares = 0
	n_matched_GOES_Bflares = 0
	n_missed_GOES_Bflares = 0
		
	n_X = 0
	n_M = 0
	n_C = 0
	n_B = 0				
	
	missed_GOES_Xdetections = 0	
	missed_GOES_Mdetections = 0
	
	str_missed_GOES_Xdetections = 'no missed Xflares'
	str_missed_GOES_Mdetections = 'no missed Mflares'
	
	ngoes_thisrun = 'n.a.'
				
	significance7 = [0]
	
	type_array = strarr(1) ; array for string-elements.  Current element is empty string. 
	
	; EUV-flare structure towards database
	; ORIG
	; template_01 = {$
	;	date:'2011/03/08', $   
	;	t1: '00:12' , $         
	;	t2: '00:27' , $
	;	loc: 'NE' , $          
	;	maxvalue: 2, $    ; maximum value of eventmovie_thisregion
	;	dt: 5, $
	;	flare_size: 1, $
	;	EUV_significance: 11, $
	;	type: 'EUVsomething', $
	;	nr: 0 }
		
	template_01= {$
			nr: 0, $   ; number of event  (0l = long, 2 exp 64)  (0 = int, 2 exp 32)  (0.0 = float) 
			type: 'no_event', $ 		; if distinction between EUVflare and EUVdyn required: EUVflare or EUVdyn
			date: '2010-10-10' , $         	; observation date yyyy-mm-dd
			starttime: '00:00:00' , $			; HH:MM
			endtime: '23:59:59' ,$
			macropixel_xpos: 0l, $	; x= 0:15 (rebinsize-1)
			macropixel_ypos: 0l, $	; y= 0:15 (rebinsize-1)		   
			macropixel_xpos_HC: 0.0, $	; heliocentric in arcseconds x= -480:+480 * pres
			macropixel_ypos_HC: 0.0, $	; heliocentric in arcseconds y= -480:+480 * pres	   
			position_HG_Stonyhurst:'W00N00', $	; heliographic Stonyhurst -90:+90
			posN_HG_St:'00', $			; heliographic Stonyhurst
			posS_HG_St: '00', $  			; heliographic Stonyhurst
			posE_HG_St: '00', $ 			; heliographic Stonyhurst
			posW_HG_St: '00', $ 			; heliographic Stonyhurst
			carrLON: 0.0, $
			maxvalue: 2, $    ; maximum value of eventmovie_thisregion	
			eventsize: 0l, $  ; max number of macropixel spatially involved
			dt: 0l, $  ; number of images in time covering event
			euvSignificance: 0.0, $
			thisgoesmatch: files[0].goesmatch, $	
			thisgoesstarttime: files[0].goesstarttime, $
			thisgoesendtime: files[0].goesendtime, $
			thisgoestype: files[0].goestype, $
			thisgoes_NOAA_region: files[0].goes_NOAA_region }
			
	
	IF max(regions) gt 0 THEN BEGIN	
		thisflare = replicate(template_01, max(regions)) ; # structures = # events (r) : 0 --> r-1
	ENDIF ELSE BEGIN
		thisflare = template_01
		sofast_events = thisflare
		save, filename=eventdir+'STR_sofast_events.sav', sofast_events ; structure of structure elements, one element per event ;#DAB
	ENDELSE
	
	header_line_array = strarr(1)
	
				
	n_X = 0
	n_M = 0
	n_C = 0
	n_B = 0				
	
	missed_GOES_Xdetections = 0	
	missed_GOES_Mdetections = 0
	
	str_missed_GOES_Xdetections = 'no missed Xflares'
	str_missed_GOES_Mdetections = 'no missed Mflares'
	
	; END INITIALISING PARAMETERS AND FLARE-STRUCTURE (for database output)
	
	
	
	; OBTAINING ALL OBSERVATION INFO PER EVENT (region) R    (starttime, endtime, ...).
	
	IF max(regions) gt 0 THEN BEGIN ; !!!! jumps all the way to line 1119
	
	contours_array = PtrArr(max(regions)) ; Create an array of arrays with #max(regions) array-elements
		
		FOR r=1, max(regions) DO BEGIN
			timeline = total(total(regions eq r,1),1) ;  count of macropixels per image, will show a value for the concerning region, result is 1D array in time-													 direction with dimension3 of regions ("eq r" puts values where "eq r" to 1 before calculating total)
			timerange=where(timeline,ntimerange) ; positions of where interesting macropixels for concerning region, ntimerange = # images for region r
			IF ntimerange eq 0 THEN stop ; not really possible?
			
			timestart = min(timerange) ; position in time dimension of first image concerning region r
			timeend = max(timerange) ; position in time dimension of last image concerning region r
			; stop ; print, r, timestart, timeend, files[timestart].date, files[timeend].date
			rbegindate[r]   = files[timestart].date ; date of first image for that region r
			renddate[r]		= files[timeend].date
			;r_starthour[r]	= files[timestart].obstime					
			r_starthour	= strmid(strtrim(1000000+files[timestart].obstime, 2), 1, 6)   ; (6 characters HHMMSS, as from position 1)
			rbegintime[r] = r_starthour
			r_endhour	= strmid(strtrim(1000000+files[timeend].obstime, 2), 1, 6)	; (6 characters HHMMSS, as from position 1)
			rendtime[r] = r_endhour
	
			wthisregion = where(regions eq r, n_wthisregion) ; ! REGIONS = 3D
			w_NOT_thisregion = where(regions ne r, n_NOT_wthisregion)
	
			regions_temp = regions
			regions_temp[w_NOT_thisregion]=0
			regions_temp=total(total(regions_temp,1),1)
			w_NOT_thisregion_final = where(regions_temp eq 0, n_NOT_wthisregion_final)
	
	
			; DEFINE MAXVALUE OF EVENTMOVIE_THISREGION = DEFINE PRINCIPAL MP (+SAVE SNAPSHOT IN TIME OF EVENTMOVIE AT MAXPOS)
			lifetime_thisregion = timeend - timestart + 1 ; #images
			
			IF n_wthisregion gt 0 THEN BEGIN
				eventmovie_thisregion = eventmovie[*,*,timestart:timeend] ; timestart:timeend is position compared to original dim3 regions, check.
				regions_thisregion = regions[*,*,timestart:timeend]
				
				maxarray = [0]
				posm_array = [0]
				
				temp=eventmovie_thisregion
				temp[where (regions_thisregion ne r)]=0
		
				FOR l=0, (((size(eventmovie_thisregion))[3]) - 1) DO BEGIN ; = timeend - timestart + 1 - 1 = lifetime_thisregion - 1
					m = max(temp[*,*,l], posm) ; find max value of thisregion = on position posm IN IMAGE (l)
					maxarray = [maxarray, m] ; save this max value in maxarray: maxvalues for all regions in 1array
					posm_array = [posm_array, posm] ; save its position in posm_array: pos for all these maxima in 1array
													; = NOT POSITION IN REDUCED ARRAY (THISregion) BUT IN IMAGE
				ENDFOR ; FOR l=0
				
				maxarray = maxarray[1:n_elements(maxarray)-1]
				posm_array = posm_array[1:n_elements(posm_array)-1]
				
				maxvalue = max(maxarray, pos) ; maximum value of eventmovie_thisregion.  pos = IN REDUCED ARRAY size thisregion
				posmaxvalue = posm_array[pos] ; posmaxvalue = position of macropixel = IN ITS IMAGE where maximum value of eventmovie occurs for this region
	
				
	 	     	plot_eventmovie_thisregion = temp[*,*,pos] ; slice in time of eventmovie_thisregion where maximum value of eventmovie_thisregion occurs
	 	     	save, filename = savdir+'plot_eventmovie_thisregion_'+strmid(strtrim(1000+r,2),1,3)+'.sav', plot_eventmovie_thisregion
	
				
				; DEFINE X AND Y OF PRINCIPAL MP, then RESTORE MAX/MIN/INTENSITY MP + CALCULATE MAIN MP STATISTICAL PARAMETERS
				x_p = posmaxvalue mod ((size(eventmovie))[1]) ; x_p = x_posmaxvalue ; (size(eventmovie))[1] = rebinsize
				y_p = (( posmaxvalue - (posmaxvalue mod ((size(eventmovie))[1])) ) / ((size(eventmovie))[1])) ; (size(eventmovie))[1] = rebinsize ; y counts from down up
	
				print, 'region number is ', r
				print, 'maximum value of eventmovie this region is ', maxvalue, 'x_p is ', x_p, 'y_p is ', y_p
			
				restore, savdir+'timeline_maxima_thismacropixel_X'+strtrim(x_p,2)+'_Y'+strtrim(y_p,2)+'.sav' ; timeline_maxima_thismacropixel PIXEL NIVEAU
				restore, savdir+'timeline_minima_thismacropixel_X'+strtrim(x_p,2)+'_Y'+strtrim(y_p,2)+'.sav' ; timeline_minima_thismacropixel PIXEL NIVEAU
	;			macropixel_int_thismacropixel_thisevent = macropixel_int[timestart:timeend]
				restore, savdir+'macropixel_int_X'+strtrim(x_p,2)+'_Y'+strtrim(y_p,2)+'.sav' ; macropixel_int
				
				avg_macropixelint_thismacropixel_THISRUN = mean(macropixel_int) ; first rebinned ; over complete THISRUN ((half) a day?)
				macropixel_int_THISDAY = macropixel_int[where(files.date eq files[timestart].date)]
				
				avg_macropixelint_thismacropixel_THISDAY = mean(macropixel_int_THISDAY) ; over 1DAY i.e. day starttime
			
				avg_macropixelint_thismacropixel_THISEVENT = mean(macropixel_int[timestart:timeend]) ; first rebinned ; over complete THISRUN (one day?)
				
				max_macropixelint_thismacropixel_THISEVENT = max(macropixel_int[timestart:timeend]) ; max rebinned int this macropixel during this event
				min_macropixelint_thismacropixel_THISEVENT = min(macropixel_int[timestart:timeend]) ; min rebinned int this macropixel during this event
	
				macropixel_int_THISEVENT = macropixel_int[timestart:timeend]
				macropixel_int_THISEVENT_zeros = macropixel_int
				macropixel_int_THISEVENT_zeros[w_NOT_thisregion_final] = 0			
				
				w_NOT_thisregion_final_THISDAY = w_NOT_thisregion_final[where(files.date eq files[timestart].date)]
				macropixel_int_THISDAY_zeros = macropixel_int_THISDAY
				macropixel_int_THISDAY_zeros[w_NOT_thisregion_final_THISDAY] = 0			

				max_macropixel_int_thismacropixel_thisevent = max(timeline_maxima_thismacropixel[timestart:timeend]) ; not necessary sister_timestart:...
				maxmax_macropixel_int_thismacropixel_thisevent = max(timeline_maxima_thismacropixel[timestart:timeend]) ; idem
							
				min_macropixel_int_thismacropixel_thisevent = min(timeline_minima_thismacropixel[timestart:timeend])	; not using sister_timestart
				minmax_macropixel_int_thismacropixel_thisevent = min(timeline_maxima_thismacropixel[timestart:timeend]) ; lowest maximum
	
				diff_int_thismacropixel_thisevent_NEW_maxmin = maxmax_macropixel_int_thismacropixel_thisevent - minmax_macropixel_int_thismacropixel_thisevent
				
				diff_int_thismacropixel_thisevent_NEW_max_towards_avg = max_macropixel_int_thismacropixel_thisevent - avg_macropixelint_thismacropixel_THISRUN
				
				significance_thisregion_7 = ( (max_macropixelint_thismacropixel_THISEVENT - min_macropixelint_thismacropixel_THISEVENT) / avg_macropixelint_thismacropixel_THISDAY )*100  ; diff max - min this macropixel this event compared to average int this macropixel this run (typically 1 day)
													; in PERCENTAGE
	
			ENDIF ELSE begin ; IF n_wthisregion gt 0
				maxvalue = 'no value for maxvalue in region_plotter'
			ENDELSE
			
			
			; CHECK IF THE DETECTED REGION CONCERNS A GOES FLARE
			goes_thisregion = where(goesflares.date ge rbegindate[r] and goesflares.date le renddate[r], ngoes_thisregion) ; goesflares defined on line 46
					
			IF ngoes_thisregion gt 0 THEN BEGIN
				goesflares_thisregion = goesflares[goes_thisregion]
				
				print, goesflares_thisregion.xra_beg, goesflares_thisregion.xra_end, goesflares_thisregion.xra_mag
			
				FOR k=0, ngoes_thisregion-1 DO BEGIN
				
					IF (strmid(strtrim(r_starthour,2), 0, 2)*60 + strmid(strtrim(r_starthour,2), 2, 2)) ge (strmid(strtrim(goesflares_thisregion								[k].xra_beg,2), 0, 2)*60 + strmid(strtrim(goesflares_thisregion[k].xra_beg,2), 2, 2)-20) and (strmid(strtrim(r_starthour,2), 0, 2)*60 + 					strmid(strtrim(r_starthour,2), 2, 2)) le (strmid(strtrim(goesflares_thisregion[k].xra_end,2), 0, 2)*60 + strmid(strtrim									(goesflares_thisregion[k].xra_end,2), 2, 2)+30) THEN BEGIN  ; 23-06-2011 comparing HHMM !!  (multiplication with 60 for the hours)
	
						files[timestart:timeend].goesmatch = 'yes GOESflare'
						files[timestart:timeend].goesstarttime = goesflares_thisregion[k].xra_beg
						files[timestart:timeend].goesendtime = goesflares_thisregion[k].xra_end
						files[timestart:timeend].goestype = goesflares_thisregion[k].xra_mag
						files[timestart:timeend].goes_NOAA_region = goesflares_thisregion[k].xra_reg
						
						notgoes=where(detections_not_GOES ne 0, n_detections_not_GOES)
						
						IF n_detections_not_GOES gt 0 THEN BEGIN
							detections_not_GOES[r-1] = 0
						ENDIF ; IF n_detections_not_GOES gt 0
											
					ENDIF ; strmid....
					
				ENDFOR ; FOR k=0, ngoes_thisregion-1
							
			ENDIF ; IF ngoes_thisregion gt 0
				
			
			;rmaxswavint = max(files[timestart:timeend].max_int_rebinned_img) 	; maximum macropixel intensity in region during event.  DOESN'T ALWAYS HAVE TO BE 
																				; IN THE ACTUAL REGION r.  SINCE WE LOOK AT INTENSITY DIFFERENCE, WE MIGHT HAVE A 
																				; LARGE DIFF WHERE INTENSITY IS LOWER THAN ELSEWHERE.
	
			; below: simply giving easy names to representive tags at moment timestart
			rgoesmatch = files[timestart].goesmatch
			rgoesstart = files[timestart].goesstarttime
			rgoesend = files[timestart].goesendtime
	 		rgoestype = files[timestart].goestype
	 		rgoesregion = files[timestart].goes_NOAA_region
			
						
			; CALCULATE HELIOGRAPHIC CO-ORDINATES
	 		pres = files[0].pixelresolution_thisrun ; in arcseconds
	 
	 		sc_HGlat_deg = files[0].b0_scenter_HGlatitude_thisrun ; in degrees
	 		sc_HGlat_rad = sc_HGlat_deg*!pi/180
	 
	 		rsun = files[0].rsun_thisrun ; in arcseconds
	 
	 		; pi = !pi
	
	 		IF x_p ge (rebinsize/2) THEN BEGIN ; 16 --> 8
	 			x_p_lonlat = ( (x_p - ((rebinsize/2)-1) )*(xres/rebinsize) - (xres/rebinsize)/2 ) * pres        ; 7
	 		ENDIF ELSE BEGIN 
				x_p_lonlat = ( (x_p - (rebinsize/2) )*(xres/rebinsize) + (xres/rebinsize)/2 ) * pres 			
			ENDELSE
	 		
	 		
	 		IF y_p ge (rebinsize/2) THEN BEGIN ; 16 --> 8
	 			y_p_lonlat = ( (y_p - ((rebinsize/2)-1) )*(yres/rebinsize) - (yres/rebinsize)/2 ) * pres        ; 7
	 		ENDIF ELSE BEGIN 
				y_p_lonlat = ( (y_p - (rebinsize/2) )*(yres/rebinsize) + (yres/rebinsize)/2 ) * pres 			
			ENDELSE
	
			; stop ; print, files[timestart].obstime
			ang = [x_p_lonlat, y_p_lonlat]
			date0 = begindate
			; b0 = sc_HGlat_rad ; depending on whether PROBA2 is in ecliptical plane of the Earth..
			rsun = rsun
	
			LON_LAT_position = sofast_xy2lonlat(ang, date0) ;, b0=b0, radius=rsun) ; results in 2 element array, [0] is solar longitude WE with W=positive, [1] is solar latitude NS with N=positive
			
			; obstime for calculation Carrington Longitude
			carr_obstime_thisregion = date0+'T'+strmid(r_starthour,0,2)+':'+strmid(r_starthour,2,2)+':'+strmid(r_starthour,4,2)
			; stop ; print, tim2carr(carr_obstime_thisregion)
			carringtonLON = (LON_LAT_position[0] + tim2carr(carr_obstime_thisregion) + 360) mod 360
			carringtonLON_round = round(carringtonLON)
	
			; first print NORTH-SOUTH, following Solar Monitor....  (solar North is positive)
			IF LON_LAT_position[1] ge 0 THEN BEGIN       
				event_pos_NS = 'N'+strmid(strtrim(100+round(LON_LAT_position[1]), 2), 1, 2)
				event_pos_N = strmid(strtrim(100+round(LON_LAT_position[1]), 2), 1, 2)
				event_pos_S = '00'
			ENDIF ELSE BEGIN
				event_pos_NS = 'S'+strmid(strtrim(100+abs(round(LON_LAT_position[1])), 2), 1, 2)
				event_pos_N = '00'
				event_pos_S = strmid(strtrim(100+abs(round(LON_LAT_position[1])), 2), 1, 2)
			ENDELSE
	
	
			; then print SOUTH-WEST, following Solar Monitor....   (solar West is positive)
			IF LON_LAT_position[0] ge 0 THEN BEGIN       
				event_pos_WE = 'W'+strmid(strtrim(100+round(LON_LAT_position[0]), 2), 1, 2)
				event_pos_W = strmid(strtrim(100+round(LON_LAT_position[0]), 2), 1, 2)
				event_pos_E = '00'
			ENDIF ELSE BEGIN
				event_pos_WE = 'E'+strmid(strtrim(100+abs(round(LON_LAT_position[0])), 2), 1, 2)
				event_pos_W = '00'
				event_pos_E = +strmid(strtrim(100+abs(round(LON_LAT_position[0])), 2), 1, 2)
			ENDELSE
	
			event_pos = event_pos_NS+event_pos_WE ; e.g. S57E33
		;stop ; print, LON_LAT_position, 'event_pos_NS=', event_pos_NS, 'event_pos_WE=', event_pos_WE
			
			
			; OUTPUT ALL DATA OF THE EVENT (r) TO SoFAST_events_SWAP_begindate.txt FILE in eventdir
			print, r, '   ', rbegindate[r], '   ', r_starthour, '   ', r_endhour, ' ', event_pos, ' ', max(timeline) , '   ', round(lifetime_thisregion), '   ', significance_thisregion_7, '   ', rgoesmatch, '   ', rgoesstart, '   ', rgoesend, '   ', rgoestype, '   ', rgoesregion 
			
					; max(timeline) gives max occuring detections in 1 image for region r (SIZE) 
					; maxvalue gives highest value of eventmovie for this event 
					; lifetime_thisregion gives # images in region in time (DT)
		
			OPENW, lun2, eventdir+'SoFAST_events_SWAP_'+begindate+'.txt', /get_lun, width=200, /append ; append to write on next line instead of overwriting in next iteration (loop r) ;#DAB
			
			printf, lun2, '      ', strmid(strtrim(1000+r,2),1,3), ' | ', rbegindate[r], ' | ', strmid(r_starthour,0,2)+':'+strmid(r_starthour,2,2)+':'+strmid(r_starthour,4,2), ' | ', strmid(r_endhour,0,2)+':'+strmid(r_endhour,2,2)+':'+strmid(r_endhour,4,2), ' | ', event_pos, ' | ', strmid(strtrim(1000+round(max(timeline)),2),1,3), '  | ', strmid(strtrim(1000+round(lifetime_thisregion),2),1,3), '  |  ', strmid(strtrim(1000+round(significance_thisregion_7),2),1,3) 		
			CLOSE, lun2
			FREE_LUN, lun2
		
			OPENW, lun9, eventdir+'SoFAST_events_SWAP_'+begindate+'_compared_to_GOESflarelist.txt', /get_lun, width=200, /append ;#DAB
			printf, lun9, '      ', strmid(strtrim(1000+r,2),1,3), ' | ', rbegindate[r], ' | ', strmid(r_starthour,0,2)+':'+strmid(r_starthour,2,2)+':'+strmid(r_starthour,4,2), ' | ', strmid(r_endhour,0,2)+':'+strmid(r_endhour,2,2)+':'+strmid(r_endhour,4,2), ' | ', event_pos, ' | ', strmid(strtrim(1000+round(max(timeline)),2),1,3), '  | ', strmid(strtrim(1000+round(lifetime_thisregion),2),1,3), '  |  ', strmid(strtrim(1000+round(significance_thisregion_7),2),1,3), '              | ', rgoesmatch, ' | ', strmid(rgoesstart,0,2)+':'+strmid(rgoesstart,2,2), '     |  ', strmid(rgoesend,0,2)+':'+strmid(rgoesend,2,2), '  | ', rgoestype, '    |  ', rgoesregion 	
			CLOSE, lun9
			FREE_LUN, lun9
		
			; OUTPUT EVENTS TO TXT FILE FOR COMESEP IF EUV_SIGNIFICANCE > 7%
			
			IF significance_thisregion_7 gt 7 THEN BEGIN ;#DAB
				OPENW, lun0, eventdir+'SoFAST_events_SWAP_for_comesep_euv_sign_gt_7pc_'+begindate+'.txt', /get_lun, width=200, /append ; append to write on next line instead of overwriting in next iteration (loop r)
				
				printf, lun0, '      ', strmid(strtrim(1000+r,2),1,3), ' | ', rbegindate[r], ' | ', strmid(r_starthour,0,2)+':'+strmid(r_starthour,2,2)+':'+strmid(r_starthour,4,2), ' | ', strmid(r_endhour,0,2)+':'+strmid(r_endhour,2,2)+':'+strmid(r_endhour,4,2), ' | ', event_pos, ' | ', strmid(strtrim(1000+round(max(timeline)),2),1,3), '  | ', strmid(strtrim(1000+round(lifetime_thisregion),2),1,3), '  |  ', strmid(strtrim(1000+round(significance_thisregion_7),2),1,3) 		
				CLOSE, lun0
				FREE_LUN, lun0
			ENDIF
			
			; ORIGINALLY DISTINCTION WAS REQUIRED BETWEEN EUV-FLARE (>sign_threshold) AND WEAKER EUVdyn
			significance7 = [significance7, significance_thisregion_7]
			
			IF significance_thisregion_7 ge sign_threshold THEN BEGIN
		 		print, 'significance_thisregion_7 ge sign_threshold'
				type_thisregion = 'EUVflare'
			ENDIF ELSE BEGIN
		 		print, 'significance_thisregion_7 LOWER THAN sign_threshold'
		 		type_thisregion = 'EUVflare'
				; type_thisregion = 'EUVdyn' ; if distinction required
		 	ENDELSE
		 
			type_array = [type_array, type_thisregion]
		
			header_line = sofast_headerline(type_thisregion)
			header_line_array = [header_line_array, header_line]
		
		
			; ENTER ALL VALUES IN THE CREATED FLARE STRUCTURE, FOR THIS FLARE r
			thisflare[r-1].nr = strmid(strtrim(1000+r,2),1,3) ;STRNR(r,3) & --> 001
			thisflare[r-1].type = type_thisregion
			thisflare[r-1].date = rbegindate[r]  
			thisflare[r-1].starttime = strmid(r_starthour,0,2)+':'+strmid(r_starthour,2,2)+':'+strmid(r_starthour,4,2)       
			thisflare[r-1].endtime = strmid(r_endhour,0,2)+':'+strmid(r_endhour,2,2)+':'+strmid(r_endhour,4,2)
			thisflare[r-1].macropixel_xpos = x_p			
			thisflare[r-1].macropixel_ypos = y_p	
			thisflare[r-1].macropixel_xpos_HC = x_p_lonlat
			thisflare[r-1].macropixel_ypos_HC = y_p_lonlat
			thisflare[r-1].position_HG_Stonyhurst = event_pos
			thisflare[r-1].posN_HG_St = event_pos_N
			thisflare[r-1].posS_HG_St = event_pos_S
			thisflare[r-1].posE_HG_St = event_pos_E
			thisflare[r-1].posW_HG_St = event_pos_W
			thisflare[r-1].carrLON = carringtonLON
			thisflare[r-1].maxvalue = maxvalue 
			thisflare[r-1].eventsize = max(timeline)
			thisflare[r-1].dt = lifetime_thisregion
			thisflare[r-1].euvSignificance = significance_thisregion_7 ; exact floating value 
			
			thisflare[r-1].thisgoesmatch = rgoesmatch
			thisflare[r-1].thisgoesstarttime = rgoesstart
			thisflare[r-1].thisgoesendtime = rgoesend
			thisflare[r-1].thisgoestype = rgoestype
			thisflare[r-1].thisgoes_NOAA_region = rgoesregion


			;thisflare_array = [thisflare_array, thisflare]
			
	
	
			; PLOT MACROPIXEL INTENSITY FOR THIS REGION/EVENT
	 	    spawn, 'mkdir '+eventdir+type_thisregion+'_'+strmid(strtrim(1000+r,2),1,3)	;instead of mkdir on line 573	
	
			outdimx=800   
			outdimy=800
			IF not keyword_set(crontab) THEN window, 0, xs=outdimx, ys=outdimy ELSE BEGIN
	      			set_plot, 'Z'
	      			device, set_resolution = [outdimx,outdimy]   ; size of image
	      			device, z_buffering    = 0           ; 0 for 2D
	   		ENDELSE       
	
			; set color table
				device, decomposed=0 
				RED			=indgen(256)
	  			GREEN		=indgen(256)
	 		 	BLUE 		=indgen(256)
	 		 	RED[0:5]  	=[0,	0,		0,		255,	255,	255]	      
	 		  	GREEN[0:5]	=[0,	0,		255,	255,	0,		0]	      
	 		  	BLUE[0:5] 	=[0,	255,	0,		0,		0,		255]
			   	; 0=black, 1=blue, 2=green, 3=yellow, 4=red, 5=purple, 255=white
			   	IF not keyword_set(sol055) THEN BEGIN
			   		TVLCT,RED,GREEN,BLUE
				ENDIF
				!p.background = 255	
			
			curve = macropixel_int_THISDAY ; = macropixel_int ; Macropixel intensity of this macropixel during "this run"
			plot, curve, color=0 
			oplot, macropixel_int_THISDAY_zeros, color=4
			; oplot, macropixel_int_THISEVENT_zeros, color=4 ; pointing out where THISREGION is in red
			IF not keyword_set(sol055) THEN BEGIN
				tvlct, rcolor, gcolor, bcolor, /get
			ENDIF
			c=tvrd()
			
			IF not keyword_set(sol055) THEN BEGIN
				write_png, eventdir+type_thisregion+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'macropixel_int_THISREGION_'+strmid(strtrim(1000+r,2),1,3)+'.png', c, rcolor, gcolor, bcolor
			ENDIF ELSE BEGIN
				write_png, eventdir+type_thisregion+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'macropixel_int_THISREGION_'+strmid(strtrim(1000+r,2),1,3)+'.png', c, RED, GREEN, BLUE
			ENDELSE
			
			
			
		ENDFOR ; FOR r=1, max(regions) DO begin  !!!!  (line 220)
		sofast_events = thisflare
		save, filename=eventdir+'STR_sofast_events.sav', sofast_events ; structure of structure elements, one element per event ;#DAB
		
		
		significance7 = significance7[1:(n_elements(significance7)-1)]
		type_array = type_array[1:(n_elements(type_array)-1)]
		;thisflare_array = thisflare_array[1:(n_elements(thisflare_array)-1)] ; first element = template_01 is not necessary anymore
		header_line_array = header_line_array[1:(n_elements(header_line_array)-1)]
		
	
		; TOWARDS LYRA FLARE AMPLITUDE
		rbegindate = rbegindate[1:n_elements(rbegindate)-1]
		renddate = renddate[1:n_elements(renddate)-1]
		rbegintime = rbegintime[1:n_elements(rbegintime)-1] ; first element was zero, first region corresponds with element on position 1
		rendtime = rendtime[1:n_elements(rendtime)-1]	
		;save, filename = savdir+'thisrun_alldetections_begindate_begintimes_endtimes_HHMMSS.sav', rbegindate, rbegintime, rendtime 
																						; arrays with n_elements = # regions (detections)
	
		
	
		; CHECK WHICH GOES FLARES ARE DETECTED / WHICH MISSED (statistics)	; write this info to SoFAST_missed_eventlist_GOES_detected_'+begindate+'.txt
		OPENW, lun3, eventdir+'SoFAST_missed_eventlist_GOES_detected_'+begindate+'.txt', /get_lun, width=200, /append ;#DAB
	   	printf, lun3, ':Issued: '+systime()
	   	printf, lun3, ':Product: SoFAST catalogue (http://www.sidc.be/sofast)'
	   	printf, lun3, '#----------------------------------------------------------------------'
	   	printf, lun3, '# Instrument: SWAP| Detector: CMOS APS 1024 x 1024'
	   	printf, lun3, '# Flare-threshold : 2 | Rebinsize : 16 | Maxhits : 4 | Offset : 65'
	   	printf, lun3, '# Modus : (1) SW service <!--(2) Onboard (rebinfirst)-->'
	   	printf, lun3, '#' 
	   	printf, lun3, '  first SWAP image this run: '+first_SWAP_thisrun_final
	   	printf, lun3, '  last  SWAP image this run: '+last_SWAP_thisrun_final
	   	printf, lun3, '#'   
	   	printf, lun3, '#' 
			
		printf, lun3, 'GOES FLARES DETECTED OR MISSED BY SWAP?'
		printf, lun3, '   ' ; white line
		CLOSE, lun3		
		FREE_LUN, lun3
	
	
		goes_thisrun = where(goesflares.date ge files[0].date and goesflares.date le files[n_elements(files)-1].date, ngoes_thisrun)
			
		IF ngoes_thisrun gt 0 THEN BEGIN
	
			goesflares_thisrun = goesflares[goes_thisrun]	
	
			missed_GOES_Xdetections = indgen(ngoes_thisrun)+1		
			missed_GOES_Mdetections = indgen(ngoes_thisrun)+1
				
			goes_Xflares= where (strmid(strtrim(goesflares_thisrun.xra_mag, 2), 0, 1) eq 'X', n_X)			
			goes_Mflares= where (strmid(strtrim(goesflares_thisrun.xra_mag, 2), 0, 1) eq 'M', n_M)
			goes_Cflares= where (strmid(strtrim(goesflares_thisrun.xra_mag, 2), 0, 1) eq 'C', n_C)
			goes_Bflares= where (strmid(strtrim(goesflares_thisrun.xra_mag, 2), 0, 1) eq 'B', n_B)				
			
			FOR l=0, n_elements(goesflares_thisrun)-1 DO BEGIN
			
				thisgoesflare_detected = where (files.goesstarttime eq goesflares_thisrun[l].xra_beg, n)
				IF n gt 0 THEN BEGIN
			
						OPENW, lun3, eventdir+'SoFAST_missed_eventlist_GOES_detected_'+begindate+'.txt', /get_lun, width=200, /append ;#DAB
						print, 'In sofast_region_plotter.pro line 780 lun3 = ', lun3 ; KB 13112014 added for test "all logical units are currently in use"
							printf, lun3, goesflares_thisrun[l].date, '   ', goesflares_thisrun[l].xra_beg, '   ', goesflares_thisrun[l].xra_end, '   ', goesflares_thisrun[l].xra_mag, '   ', goesflares_thisrun[l].xra_reg, '   DETECTED BY SWAP'
						CLOSE, lun3
						FREE_LUN, lun3
						
						n_matched_GOES_events = n_matched_GOES_events + 1
						
						IF strmid(strtrim(goesflares_thisrun[l].xra_mag, 2), 0, 1) eq 'X' THEN BEGIN
							n_matched_GOES_Xflares = n_matched_GOES_Xflares + 1
						ENDIF
						
						IF strmid(strtrim(goesflares_thisrun[l].xra_mag, 2), 0, 1) eq 'M' THEN BEGIN
							n_matched_GOES_Mflares = n_matched_GOES_Mflares + 1
						ENDIF
							
						IF strmid(strtrim(goesflares_thisrun[l].xra_mag, 2), 0, 1) eq 'C' THEN BEGIN
							n_matched_GOES_Cflares = n_matched_GOES_Cflares + 1
						ENDIF
							
						IF strmid(strtrim(goesflares_thisrun[l].xra_mag, 2), 0, 1) eq 'B' THEN BEGIN
							n_matched_GOES_Bflares = n_matched_GOES_Bflares + 1
						ENDIF	
						
				ENDIF ELSE BEGIN ; IF n gt 0
						OPENW, lun3, eventdir+'SoFAST_missed_eventlist_GOES_detected_'+begindate+'.txt', /get_lun, width=200, /append ;#DAB
						print, 'In sofast_region_plotter.pro line 805 lun3 = ', lun3 ; KB 13112014 added for test "all logical units are currently in use"
						printf, lun3, goesflares_thisrun[l].date, '   ', goesflares_thisrun[l].xra_beg, '   ', goesflares_thisrun[l].xra_end, '   ', goesflares_thisrun[l].xra_mag, '   ', goesflares_thisrun[l].xra_reg, '   MISSED BY SWAP'
						CLOSE, lun3
						FREE_LUN, lun3
						
						n_missed_GOES_events = n_missed_GOES_events + 1
	
						IF strmid(strtrim(goesflares_thisrun[l].xra_mag, 2), 0, 1) eq 'X' THEN BEGIN
							n_missed_GOES_Xflares = n_missed_GOES_Xflares + 1							
							missed_GOES_Xdetections[l] = 0 ; 0 where missed Xflare
						ENDIF
						
						IF strmid(strtrim(goesflares_thisrun[l].xra_mag, 2), 0, 1) eq 'M' THEN BEGIN
							n_missed_GOES_Mflares = n_missed_GOES_Mflares + 1							
							missed_GOES_Mdetections[l] = 0 ; 0 where missed Mflare
						ENDIF
						
						IF strmid(strtrim(goesflares_thisrun[l].xra_mag, 2), 0, 1) eq 'C' THEN BEGIN
							n_missed_GOES_Cflares = n_missed_GOES_Cflares + 1
						ENDIF
						
						IF strmid(strtrim(goesflares_thisrun[l].xra_mag, 2), 0, 1) eq 'B' THEN BEGIN
							n_missed_GOES_Bflares = n_missed_GOES_Bflares + 1
						ENDIF
	
				ENDELSE
			
			ENDFOR ; FOR l=0, n_elements(goesflares_thisrun)-1
			
			
			missed_M = where(missed_GOES_Mdetections eq 0, n_missedM)
			str_missed_GOES_Mdetections = 'no missed Mflares'
			
			IF n_missedM gt 0 THEN BEGIN
				str_missed_GOES_Mdetections = goesflares_thisrun[missed_M]
			ENDIF
			
			missed_X = where(missed_GOES_Xdetections eq 0, n_missedX)
			str_missed_GOES_Xdetections = 'no missed Xflares'
			
			IF n_missedX gt 0 THEN BEGIN
				str_missed_GOES_Xdetections = goesflares_thisrun[missed_X]
			ENDIF	
			
		ENDIF ; IF ngoes_thisrun gt 0
		
		
		
		; MORE PLOTS PER EVENT ~ NEW LOOP OVER ALL EVENTS
		
		;******************* PLOT 1. eventdir/flaredir/ **_compared_GOES.png *******************
	
		
		rday  = strmid(rbegindate, 8, 2) ; applies on each element in whole array, taking 2 characters as from position 8 ; 2010-10-16 --> 16
	
		FOR r=1, max(regions) DO BEGIN 
			
			day=rday[r-1] ; e.g. 2010-10-16 --> 16
			date=rbegindate[r-1] ; e.g. 2010-10-16
			end_date=renddate[r-1] ; e.g. 2010-10-17
			
			; READ GOES DATA (adapting location manually with run no longer necessary)		
			date_8digits = strjoin(strsplit(date,/extract, '-'),'') ; as in 20120502 yyyymmdd (beginning date)
			enddate_8digits = strjoin(strsplit(end_date,/extract, '-'),'') ; as in 20120502 yyyymmdd, supposing an event doesn't cover more than 2 different days
			IF getGOESASCIIdata THEN BEGIN
				;beginyear  	= strmid(date_8digits, 0, 4)
				;beginmonth 	= strmid(date_8digits, 4, 2)
				;beginday   	= strmid(date_8digits, 6, 2)
				;beginday	= julday(beginmonth, beginday, beginyear)
				;day = beginday
					sofast_get_GOES_latest_ascii_data, date_8digits, goesasciidir, gtime, gsw, glw 
					;goesfile=goesdir+goes_spacecraft+day+'.fits' ; goesdir e.g. inputdir+'./', goes_spacecraft = 'go15', date_8digits=yyyymmdd
			ENDIF
			IF getGOESFITSdata THEN BEGIN
				sofast_get_goes_fits_data_1day, date=date_8digits, goes_spacecraft, goesdir=goesdir
				goesfile=goesdir+strmid(date_8digits,0,4)+'/'+goes_spacecraft+date_8digits+'.fits'
				
				check_goesfile = file_test(goesfile, /ZERO_LENGTH) ; will be 1 if empty file, will be 0 if not empty
				IF check_goesfile eq 0 THEN BEGIN
					ext2 = readfits(goesfile, htab, exten_no=2)
					gtime =  tbget( htab, ext2, 'TIME')   ; Goes TIME stamps
					gflux =  tbget( htab, ext2, 'flux')   ; Goes flux levels
					icoord=lindgen(n_elements(gflux)/2)		   ; icoord = lindgen(n_elements(gflux)/2) ; NOT icoord=lindgen(41056)	
					glw= gflux[icoord*2l]   > 0    ; Goes Long Wavelength 1.0 - 8.0 Ang
					gsw= gflux[icoord*2l-1] > 0    ; Goes Short Wavelength 0.5 - 4.0 Ang
				ENDIF ELSE BEGIN
					gtime = indgen(24*60*60) ; 86400 elements 0-->86399
	       			glw = replicate(0.0, 24*60*60)
       				gsw = replicate(0.0, 24*60*60) 	
				ENDELSE
			ENDIF 
			IF getGOESLOCALdata THEN BEGIN
				goesfile=goesdir+strmid(date_8digits,0,4)+'/'+goes_spacecraft+date_8digits+'.fits'
								;goesdir e.g. inputdir+'./', goes_spacecraft = 'go15', date_8digits=yyyymmdd
				ext2 = readfits(goesfile, htab, exten_no=2)
				gtime =  tbget( htab, ext2, 'TIME')   ; Goes TIME stamps
				gflux =  tbget( htab, ext2, 'flux')   ; Goes flux levels
				icoord=lindgen(n_elements(gflux)/2)		   ; icoord = lindgen(n_elements(gflux)/2) ; NOT icoord=lindgen(41056)	
				glw= gflux[icoord*2l]   > 0    ; Goes Long Wavelength 1.0 - 8.0 Ang
				gsw= gflux[icoord*2l-1] > 0    ; Goes Short Wavelength 0.5 - 4.0 Ang
			ENDIF
	
	
			; GET TODAY's DATA				
			restore, savdir+'regions.sav' ; again restoring (now per region), files will no longer take into account 'goesmatch', 'goesstarttime' etc...
					
			select = where(files.date ge date and files.date le end_date, nselect) ; XXX ADDED 06072011 ; "where the region is"
	
			files = files[select]
			sec = (files.obstime_n - files.date_n*86400l)  ; restricted now to files[select] ; seconds in the day ; n_seconds at observations minus n_seconds of start of the day.
			eventmovie = eventmovie[*,*,select]
			regions = regions[*,*,select]
	
			; WHEN is the region?
			timerange=where(total(total(regions eq r,1),1),ntimerange) ; eq r ~ puts values on 1 where true   ; =where(... ne 0,ntimerange) 
			IF ntimerange eq 0 THEN stop
			timestart = min(timerange)
			timeend = max(timerange)
			i = timestart
			
			; WHERE is the region?
			rmap = total(regions eq r,3) ne 0 ; rebinsize x rebinsize
			rmaploc = where(rmap)
			rmaplocy = rmaploc/rebinsize
			rmaplocx = rmaploc - rebinsize * rmaplocy	
												; NOTE X and Y 'coordinates' as follows:
												; 0
												; 1
												; 2
												; 3
												;	0 1 2 3	
			
			rmapminx = min(rmaplocx) * xwidth ; 64 pixels per macropixel
			rmapminy = min(rmaplocy) * ywidth
			rmapmaxx = max(rmaplocx) * xwidth
			rmapmaxy = max(rmaplocy) * ywidth
			
			; timeline
			; labeldate=..., xticformat
			
			thisflaredir = eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/' 
			
			
			outdimx=1400   
			outdimy=300
			IF not keyword_set(crontab) THEN window, 1, xs=outdimx, ys=outdimy ELSE BEGIN
	      			set_plot, 'Z'
	      			device, set_resolution = [outdimx,outdimy]   ; size of image
	      			device, z_buffering    = 0           ; 0 for 2D
	   		ENDELSE         
	
			; set color table
				device, decomposed=0 
				RED			=indgen(256)
	  			GREEN		=indgen(256)
	 		 	BLUE 		=indgen(256)
	 		 	RED[0:5]  	=[0,	0,		0,		255,	255,	255]	      
	 		  	GREEN[0:5]	=[0,	0,		255,	255,	0,		0]	      
	 		  	BLUE[0:5] 	=[0,	255,	0,		0,		0,		255]
			   	; 0=black, 1=blue, 2=green, 3=yellow, 4=red, 5=purple, 255=white
			   	IF not keyword_set(sol055) THEN BEGIN
			   		TVLCT,RED,GREEN,BLUE
				ENDIF
				!p.background = 255	
	
	
			plot, sec,  total(total(regions ne 0, 1),1), psym=10, color=0, xrange=[0,(24l*60l*60l)], /xstyle, xminor=1, yrange=[0,5], xmargin=[10,10], ystyle=8, yminor=1, ticklen=0.007, title=date, xtitle='SECONDS IN DAY', ytitle='# MACROPIXELS',charsize=1.3  ; "total" counts amount of locations where regions >0 
																									 ; (does not sum up values of elements regions!)
	
			plots, [sec[i],sec[i]], [0,5], /data, color=0,  thick=1, linestyle=3
			oplot, gtime, 4*glw/max(glw), psym=10, color=4 ; red
	
			axis, YAXIS=1, YRANGE = ((!Y.CRANGE)*max(glw))/4, YSTYLE=1, yminor=1, ticklen=0.007, YTITLE='GOES x-rays', color=4, charsize=1.3
	
			IF not keyword_set(sol055) THEN BEGIN
				tvlct, rcolor, gcolor, bcolor, /get   
	   		ENDIF
	   		
	   		a=tvrd()			
			
			IF not keyword_set(sol055) THEN BEGIN
				write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_compared_GOES.png', a,rcolor,gcolor,bcolor
			ENDIF ELSE BEGIN
				write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_compared_GOES.png', a,RED,GREEN,BLUE
			ENDELSE
	
			;timeline = total(total(regions eq r,1),1) 
			
	
	
		;******************* PLOT 2. eventdir/ **_Win1.png ******************* ; pre-event (at start-time)
		;******************* UNCOMMENTED: PLOT 3. eventdir/flaredir/ **_Win1.png ******************* ; pre-event (at start-time)
		
			outdimx=800   
			outdimy=800
			IF not keyword_set(crontab) THEN window, 2, xs=outdimx, ys=outdimy ELSE BEGIN
	      			set_plot, 'Z'
	      			device, set_resolution = [outdimx,outdimy]   ; size of image
	      			device, z_buffering    = 0           ; 0 for 2D
	   		ENDELSE        
	
			; set color table
				device, decomposed=0 
				RED			=indgen(256)
	  			GREEN		=indgen(256)
	 		 	BLUE 		=indgen(256)
	 		 	RED[0:5]  	=[0,	0,		0,		255,	255,	255]	      
	 		  	GREEN[0:5]	=[0,	0,		255,	255,	0,		0]	      
	 		  	BLUE[0:5] 	=[0,	255,	0,		0,		0,		255]
			   	; 0=black, 1=blue, 2=green, 3=yellow, 4=red, 5=purple, 255=white
			   	IF not keyword_set(sol055) THEN BEGIN
			   		TVLCT,RED,GREEN,BLUE
				ENDIF
				!p.background = 255
	
			
			a=readfits(files[i].url)  ; i = timestart (we show region on first image where something happens compared to his sister-image)
									 
	
			overlay=bytscl(congrid(alog10(a>1),800,800), top=249)+6
	
		
			myregions =  rebin(rmap, 800, 800, /sample) ; rmap = total(regions eq r,3) ne 0
			contours =  where( dilate(myregions, replicate(1,5,5))-myregions ne 0, ncontours)
	
			IF ncontours ge 1 then BEGIN
				overlay[contours] = ((r-1) MOD 5)+1 ; instead of 3
				contours_array[r-1] = Ptr_New(contours) ; 3=yellow, 4=red
			ENDIF
	
			tv, overlay
			; tvcircle, 242, 400, 400, color=255, THICK = 2 ; 245 ipv 250 trial and error, based on (800/16) * 5
	
			; WITH EXPLAINING TEXT		
			xyouts, 50,740, 'EVENT-nr: ', /device, color = 3, charsize = 2
			xyouts, 50,710, r, /device, color=3, charsize=2 ; 51 --> 45 show date in fits name
			xyouts, 50,680, 'pre-event (at start-time): ', /device, color = 3, charsize = 2
			Pswap=strpos(files[i].url, 'swap_')
			xyouts, 50,650, strmid(files[i].url,Pswap,45), /device, color=3, charsize=2 ; 81 --> 45 show fits name
			
			xyouts, 50,70, 'SIGNIFICANCE (% EUV relative variability): ', /device, color = 4, charsize = 2
			xyouts, 50,40, significance7[r-1], /device, color=4, charsize=2 ; 51 --> 45 show date in fits name
			
	
			IF not keyword_set(sol055) THEN BEGIN
				tvlct, rcolor, gcolor, bcolor, /get  
			ENDIF
			
	   		a=tvrd()
	   		
	   		IF not keyword_set(sol055) THEN BEGIN
				; write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_Win1.png', a, rcolor, gcolor, bcolor
				write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_Win1.png', a, rcolor, gcolor, bcolor
			ENDIF ELSE BEGIN
				write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_Win1.png', a, RED, GREEN, BLUE
			ENDELSE
			
				
				
		;******************* PLOT 4. eventdir/flaredir/ img****.png ******************* ; subfield, difference SWAPimage minus SWAPimage_sister
							
			outdimx=800   
			outdimy=800
			IF not keyword_set(crontab) THEN window, 3, xs=outdimx, ys=outdimy ELSE BEGIN
	      			set_plot, 'Z'
	      			device, set_resolution = [outdimx,outdimy]   ; size of image
	      			device, z_buffering    = 0           ; 0 for 2D
	   		ENDELSE        
	
	
	 	     	    
	 	    
	 	    FOR j = timestart, timeend DO BEGIN
	 	   	
			outdimx=800   
			outdimy=800
			IF not keyword_set(crontab) THEN window, 4, xs=outdimx, ys=outdimy ELSE BEGIN
	      			set_plot, 'Z'
	      			device, set_resolution = [outdimx,outdimy]   ; size of image
	      			device, z_buffering    = 0           ; 0 for 2D
	   		ENDELSE       
	
			; set color table
			device, decomposed=0 
			RED			=indgen(256)
	  		GREEN		=indgen(256)
	 		BLUE 		=indgen(256)
	 		RED[0:5]  	=[0,	0,		0,		255,	255,	255]	      
	 		GREEN[0:5]	=[0,	0,		255,	255,	0,		0]	      
	 		BLUE[0:5] 	=[0,	255,	0,		0,		0,		255]
			; 0=black, 1=blue, 2=green, 3=yellow, 4=red, 5=purple, 255=white
			IF not keyword_set(sol055) THEN BEGIN
				TVLCT,RED,GREEN,BLUE
			ENDIF
			!p.background = 255
	
	 	    image = readfits(files[j].url)
	 	       	
	 	    image_sister = readfits(files[j].sisterurl)
	 	    diff_image = image - image_sister ; creating diff images, always subtracting the concerning sister_image on which detection is based.
	 	    	
			diff_x = ((max(rmaplocx)+2 <(rebinsize-1)) - (min(rmaplocx)-2 >0))
			diff_y = ((max(rmaplocy)+2 <(rebinsize-1)) - (min(rmaplocy)-2 >0))
			diff = diff_x > diff_y ; chose max of those two values
	 	    myregions_map = rmap[min(rmaplocx)-2 >0 : (min(rmaplocx)-2 >0 + diff) <(rebinsize-1), min(rmaplocy)-2 >0 : (min(rmaplocy)-2 >0 + diff) <(rebinsize-1)]
	
	 	    myregions = rebin(myregions_map, (800-(800 mod (size(myregions_map))[1])), (800-(800 mod (size(myregions_map))[2])), /sample)
				
			overlay = bytscl(congrid(diff_image[(min(rmaplocx)-2 >0)*xwidth >0 : ((min(rmaplocx)-2 >0 + diff+1)*xwidth -1) <(xres-1), (min(rmaplocy)-2 >0)*ywidth >0 : ((min(rmaplocy)-2 >0 + diff+1)*ywidth -1) <(yres-1)], (800-(800 mod (size(myregions_map))[1])), (800-(800 mod (size(myregions_map))[2]))), top=249)+6 ; +6 is because in 0-5 colors are defined
				
				
			contours = where(dilate(myregions, replicate(1,5,5))-myregions ne 0, ncontours)
			
			IF ncontours ge 1 THEN overlay[contours] = 3 ; 3=yellow, 4=red
			
			tv, overlay
				
			; WITH EXPLAINING TEXT					
			xyouts, 50,740, 'EVENT-nr: ', /device, color = 3, charsize = 2
			xyouts, 50,710, r, /device, color=3, charsize=2 ; 24 --> 45 show date in fits name	
			xyouts, 50,680, 'subfield, difference SWAPimage minus SWAPimage_sister', /device, color=3, charsize=2 ; last - first interesting image
			Pswap=strpos(files[j].url, 'swap_')
			xyouts, 50,650, strmid(files[j].url,Pswap,45), /device, color=3, charsize=2 ; 81 --> 45 show fits name  (url)
			Pswapsis=strpos(files[j].sisterurl, 'swap_')
			xyouts, 50,620, strmid(files[j].sisterurl,Pswapsis,45), /device, color=3, charsize=2 ; 81 --> 45 show fits name  (url)
	 	    
	 	    IF not keyword_set(sol055) THEN BEGIN
	 	    	tvlct, rcolor, gcolor, bcolor, /get  
	   		ENDIF
	   		
	   		a=tvrd()
	 	    
	 	    IF not keyword_set(sol055) THEN BEGIN
	 	    	write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'img'+strmid(strtrim(1000+j-timestart,2),1,3)+'.png', a, rcolor, gcolor, bcolor
			ENDIF ELSE BEGIN
				write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'img'+strmid(strtrim(1000+j-timestart,2),1,3)+'.png', a, RED, GREEN, BLUE
			ENDELSE
	
	
		;******************* PLOT 5. eventdir/flaredir/ sqrt_img****.png ******************* ; subfield, sqrt SWAPimages
	
	 	    image_sqrt = sqrt(image)
	 	    	
	 	    myregions_map = rmap[min(rmaplocx)-2 >0 : (min(rmaplocx)-2 >0 + diff) <(rebinsize-1), min(rmaplocy)-2 >0 : (min(rmaplocy)-2 >0 + diff) <(rebinsize-1)]
	 	    myregions = rebin(myregions_map, (800-(800 mod (size(myregions_map))[1])), (800-(800 mod (size(myregions_map))[2])), /sample)
	 	    	
	 	    overlay = bytscl(congrid(image_sqrt[(min(rmaplocx)-2 >0)*xwidth >0 : ((min(rmaplocx)-2 >0 + diff+1)*xwidth -1) <(xres-1), (min(rmaplocy)-2 >0)*ywidth >0 : ((min(rmaplocy)-2 >0 + diff+1)*ywidth -1) <(yres-1)], (800-(800 mod (size(myregions_map))[1])), (800-(800 mod (size(myregions_map))[2]))), top=249)+6
			
			contours = where(dilate(myregions, replicate(1,5,5))-myregions ne 0, ncontours)
			
			IF ncontours ge 1 THEN overlay[contours] = ((r-1) MOD 5)+1 ; instead of 3; 3=yellow, 4=red
			
				tv, overlay
				
				; WITH EXPLAINING TEXT								
				xyouts, 50,740, 'EVENT-nr: ', /device, color = 3, charsize = 2
				xyouts, 50,710, r, /device, color=3, charsize=2 ; 24 --> 45 show date in fits name	
				xyouts, 50,680, 'subfield, sqrt SWAPimages', /device, color=3, charsize=2 ; last - first interesting image
				Pswap=strpos(files[j].url, 'swap_')
				xyouts, 50,650, strmid(files[j].url,Pswap, 45), /device, color=3, charsize=2 ; 81 --> 45 show fits name (url)
	 	    	
	 	    	IF not keyword_set(sol055) THEN BEGIN
	 	    		tvlct, rcolor, gcolor, bcolor, /get   
	   			ENDIF
	   			
	   			a=tvrd()	    
	 	    
	 	    	IF not keyword_set(sol055) THEN BEGIN
	 	    		write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'sqrt_img'+strmid(strtrim(1000+j-timestart,2),1,3)+'.png', a, rcolor, gcolor, bcolor
				ENDIF ELSE BEGIN
	 	    		write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'sqrt_img'+strmid(strtrim(1000+j-timestart,2),1,3)+'.png', a, RED, GREEN, BLUE
				ENDELSE
				
	 	    	; NEXT IS BECAUSE JPEG LOADS FASTER THAN PNG FOR MOVIES
	   			; this_image=bytscl(a) ; not needed, already -->255
				; s=size(a)
				; image3d = BYTARR(3, s(1), s(2))
	   			; image3d(0, *, *) = rcolor(a)
	  			; image3d(1, *, *) = gcolor(a)
	   			; image3d(2, *, *) = bcolor(a)
	
				; write_jpeg, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'sqrt_img'+strmid(strtrim(1000+j-timestart,2),1,3)+'.jpeg', image3d, TRUE=1   		
	 	    
	 	;******************* PLOT 6. eventdir/ ****_plot_eventmovie_thisregion.png ******************* 
	 			; plots plot_eventmovie_thisregion = a slice in time of eventmovie_thisregion where maximum value of eventmovie_thisregion occurs	    
	 	     				
				IF n_wthisregion gt 0 THEN BEGIN		
					restore, savdir+'plot_eventmovie_thisregion_'+strmid(strtrim(1000+r,2),1,3)+'.sav' ; contains plot_eventmovie_thisregion
	
	
					outdimx=800   
					outdimy=800
					IF not keyword_set(crontab) THEN window, 5, xs=outdimx, ys=outdimy ELSE BEGIN
	      				set_plot, 'Z'
	      				device, set_resolution = [outdimx,outdimy]   ; size of image
	      				device, z_buffering    = 0           ; 0 for 2D
	   				ENDELSE       
	
					; set color table
					device, decomposed=0 
					RED			=indgen(256)
	  				GREEN		=indgen(256)
	 		 		BLUE 		=indgen(256)
	 		 		RED[0:5]  	=[0,	0,		0,		255,	255,	255]	      
	 		  		GREEN[0:5]	=[0,	0,		255,	255,	0,		0]	      
	 		  		BLUE[0:5] 	=[0,	255,	0,		0,		0,		255]
			  	 	; 0=black, 1=blue, 2=green, 3=yellow, 4=red, 5=purple, 255=white
			  	 	IF not keyword_set(sol055) THEN BEGIN
			  	 		TVLCT,RED,GREEN,BLUE
					ENDIF
					!p.background = 255	
	
	 	 	    	overlay = bytscl(congrid(plot_eventmovie_thisregion,800,800), top=249)+6
	
	 	 	    	myregions =  rebin(rmap, 800, 800, /sample) ; rmap = total(regions eq r,3) ne 0
					contours =  where( dilate(myregions, replicate(1,5,5))-myregions ne 0, ncontours)
				
					IF ncontours ge 1 THEN overlay[contours] = 3 ; 3=yellow, 4=red
	
					tv, overlay	
					tvcircle, 242, 400, 400, color=255, THICK = 4 ; 245 ipv 250 trial and error, based on (800/16) * 5
	 	   		  	
	 	   		  	IF not keyword_set(sol055) THEN BEGIN
	 	   		  		tvlct, rcolor, gcolor, bcolor, /get  
	   				ENDIF
	   				
	   				a=tvrd()	
	 	   		  	
	 	   		  	IF not keyword_set(sol055) THEN BEGIN
	 	   		  		write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_plot_eventmovie_thisregion.png',  a, rcolor, gcolor, bcolor
					ENDIF ELSE BEGIN
						write_png, eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_plot_eventmovie_thisregion.png',  a, RED, GREEN, BLUE
					ENDELSE
	
				ENDIF
							    
	 	    ENDFOR 	; loop over j (timestart --> timeend)
	
	
	
	 		;******************* CREATE MOVIE 1. eventdir/flaredir/ ****_subfield_diff_images.mp4 ******************* 
	 	
	 		spawn, 'ffmpeg  -r 3.125 -i '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'img%03d.png  -vb 6000000 -pass 1 '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_subfield_diff_images.mp4' ; movie of running difference images (diff image - its sister) ; -vb instead of -b for the video bitrate (-ab for the audio bitrate)
	 		
	  		;******************* CREATE MOVIE 2. eventdir/flaredir/ ****_subfield_sqrt_images.mp4 ******************* 
			; PNG
			spawn, 'ffmpeg  -r 3.125 -i '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'sqrt_img%03d.png  -vb 6000000 -pass 1 '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_subfield_sqrt_images.mp4'
			
			; IDEM JPEG
	 		; spawn, 'ffmpeg  -r 3.125 -i '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'sqrt_img%03d.jpeg  -vb 6000000 -pass 1 '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_subfield_sqrt_images.mp4'
	 		; -vb instead of -b for the video bitrate (-ab for the audio bitrate)
	
	 		;******************* CREATE MOVIE 3. eventdir/flaredir/ FLARE.mov ******************* 
	 		
	 		; spawn, 'ffmpeg  -r 3.125 -i '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+'sqrt_img%03d.png  -vb 6000000 -pass 1 '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/FLARE.mov'
	 		; -vb instead of -b for the video bitrate (-ab for the audio bitrate)
	
			spawn, 'cp '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/'+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'_subfield_sqrt_images.mp4 '+eventdir+type_array[r-1]+'_'+strmid(strtrim(1000+r,2),1,3)+'/FLARE.mov'
	
	 	 	; START PRODUCING AN HTML PAGE PER EVENT (sofast_flare_html)    	 	     	
	; 		sofast_flare_html, thisflare_array[r-1], header_line_array[r-1], thisflaredir, eventdir=eventdir, r=r ; eventdir ~ flaredir!!
	 		sofast_flare_html, thisflare[r-1], header_line_array[r-1], thisflaredir, eventdir=eventdir, r=r ; eventdir ~ flaredir!!
					
			IF type_array[r-1] eq 'EUVflare' THEN BEGIN ;#DAB
				openw, lun7, savdir+'euvflares.txt', /get_lun, /append
	   			printf, lun7, sofast_infoline(thisflare[r-1], eventdir=eventdir, r=r)
	   			close, lun7
	   			free_lun, lun7
	   		ENDIF
	   	
			IF type_array[r-1] eq 'EUVdyn' THEN BEGIN ;#DAB
				openw, lun8, eventdir+'euvdyns.txt', /get_lun, /append 
	   			printf, lun8, sofast_infoline(thisflare[r-1], eventdir=eventdir, r=r)
	   			close, lun8
	   			free_lun, lun8
	   		ENDIF   
	 	
	
		ENDFOR ; second loop of regions r
	
	
	ENDIF ; END OF IF MAX(REGIONS) gt 0 !!!!
	
	
	
	; TOWARDS MOVIE OVERVIEW ALL DETECTIONS IN ONE IMAGE (overview includes no detection if max(regions)=0 that's OK)
	
	 ;******************* PLOT 7. eventdir/overview_SoFAST_events.png *******************
	
	
	;contours_array = contours_array[1 : n_elements(contours_array)-1] ; CHECK THIS OUT !!!! 17012012
	
	outdimx=800   
	outdimy=800
	IF not keyword_set(crontab) THEN window, 6, xs=outdimx, ys=outdimy ELSE BEGIN
	    set_plot, 'Z'
		device, set_resolution = [outdimx,outdimy]   ; size of image
	    device, z_buffering    = 0           ; 0 for 2D
	ENDELSE       
	
	; set color table
	device, decomposed=0 
	RED			=indgen(256)
	GREEN		=indgen(256)
	BLUE 		=indgen(256)
	RED[0:5]  	=[0,	0,		0,		255,	255,	255]	      
	GREEN[0:5]	=[0,	0,		255,	255,	0,		0]	      
	BLUE[0:5] 	=[0,	255,	0,		0,		0,		255]
	; 0=black, 1=blue, 2=green, 3=yellow, 4=red, 5=purple, 255=white
	IF not keyword_set(sol055) THEN BEGIN
		TVLCT,RED,GREEN,BLUE
	ENDIF
	!p.background = 255	
			
	a=readfits(files[0].url)  ; i = timestart (we show region on first image where something happens compared to his sister-image)
	
	overlay=bytscl(congrid(alog10(a>1),800,800), top=249)+6
	
	
	IF max(regions) gt 0 THEN BEGIN
		FOR m=0, n_elements(contours_array)-1 DO BEGIN
				overlay[(*contours_array[m])] = (m MOD 5)+1   ; 3=yellow, 4=red (and don't start with 0) ; (*c[m]) = element m of pointer array c
		ENDFOR
	ENDIF
	
	
	tv, overlay
	; tvcircle, 242, 400, 400, color=255, THICK = 2 ; 245 instead of 250 trial and error, based on (800/16) * 5
	
	; WITH EXPLAINING TEXT		
			xyouts, 50,740, 'SoFAST events from '+begindate+' to '+enddate, /device, color = 3, charsize = 2
	;		xyouts, 50,710, r, /device, color=3, charsize=2 ; 51 --> 45 show date in fits name
	;		xyouts, 50,680, 'pre-event (at start-time): ', /device, color = 3, charsize = 2
	;		xyouts, 50,650, strmid(files[i].url,51,45), /device, color=3, charsize=2 ; 51 --> 45 show date in fits name
			
	;		xyouts, 50,70, 'SIGNIFICANCE (% EUV relative variability): ', /device, color = 4, charsize = 2
	;		xyouts, 50,40, significance7[r-1], /device, color=4, charsize=2 ; 51 --> 45 show date in fits name
			
	
	IF not keyword_set(sol055) THEN BEGIN
		tvlct, rcolor, gcolor, bcolor, /get  
	ENDIF
	
	a=tvrd()
	
	IF not keyword_set(sol055) THEN BEGIN   		
		write_png, eventdir+'overview_SoFAST_events.png', a, rcolor, gcolor, bcolor
	ENDIF ELSE BEGIN
		write_png, eventdir+'overview_SoFAST_events.png', a, RED, GREEN, BLUE
	ENDELSE		
	; END OVERVIEW ALL DETECTIONS IN ONE IMAGE		
			
	
	; TOWARDS MOVIE OVERVIEW ALL SWAP IMAGES + INDICATED EVENTS + COMPARED TO GOES 
	
	;******************* PLOT 8. outwwwdir/ ****_compared_GOES.jpeg *******************
	
	IF n_elements(files) gt 1 THEN BEGIN ; if all images are offpointed and/or blur and/or eclipsed we reduce allfiles to allfiles[0] --> files	
							
		restore, savdir+'regions.sav' ; again restoring (now per region), files will no longer take into account 'goesmatch', 'goesstarttime' etc...
		q_count = 0
		day_count = 0
	
		FOR thisjul = files[0].beginjul, files[0].endjul DO BEGIN ; beginjul and endjul are the same for each element of files.  It is ~ begindate and enddate thisrun
		
			caldat, thisjul, thismonth, thisday, thisyear
					thisyear = strtrim(thisyear,2)
					thismonth= strmid(strtrim(thismonth+100,2),1,2)
					day  = strmid(strtrim(thisday+100,2),1,2)
	
			date = thisyear+'-'+thismonth+'-'+day ; yyyy-mm-dd idem format as files.date
			end_date = date
			print, '    ' ; KB, added 22042013
			print, 'TODAY IS '+date ; KB, added 22042013
			print, '    ' ; KB, added 22042013


			; GET TODAY's DATA
			select_today = where(files.date eq date, nselect_today) ; "where the region is"
			
			IF nselect_today gt 0 THEN BEGIN ; KB, added 22042013
				files_today = files[select_today]
				sec_today = (files_today.obstime_n - files_today.date_n*86400l) ; restricted now to files[select] 
																				; seconds in the day 
																				; n_seconds at observations minus n_seconds of start of the day.
				eventmovie_today = eventmovie[*,*,select_today]
				regions_today = regions[*,*,select_today]	
				
				; READ GOES DATA (adapting location manually with run no longer necessary)		
				date_8digits = strjoin(strsplit(date,/extract, '-'),'') ; as in 20120502 yyyymmdd (beginning date)
				enddate_8digits = strjoin(strsplit(end_date,/extract, '-'),'') ; as in 20120502 yyyymmdd, supposing an event doesn't cover more than 2 different days
				IF getGOESASCIIdata THEN BEGIN
					;beginyear  	= strmid(date_8digits, 0, 4)
					;beginmonth 	= strmid(date_8digits, 4, 2)
					;beginday   	= strmid(date_8digits, 6, 2)
					;beginday	= julday(beginmonth, beginday, beginyear)
					;day = beginday
					sofast_get_GOES_latest_ascii_data, date_8digits, goesasciidir, gtime, gsw, glw 
						;goesfile=goesdir+goes_spacecraft+day+'.fits' ; goesdir e.g. inputdir+'./', goes_spacecraft = 'go15', date_8digits=yyyymmdd
				ENDIF
				IF getGOESFITSdata THEN BEGIN
					sofast_get_goes_fits_data_1day, date=date_8digits, goes_spacecraft, goesdir=goesdir
					goesfile=goesdir+strmid(date_8digits,0,4)+'/'+goes_spacecraft+date_8digits+'.fits'
					
					check_goesfile = file_test(goesfile, /ZERO_LENGTH) ; will be 1 if empty file, will be 0 if not empty
					IF check_goesfile eq 0 THEN BEGIN
						ext2 = readfits(goesfile, htab, exten_no=2)
						gtime =  tbget( htab, ext2, 'TIME')   ; Goes TIME stamps
						gflux =  tbget( htab, ext2, 'flux')   ; Goes flux levels
						icoord=lindgen(n_elements(gflux)/2)		   ; icoord = lindgen(n_elements(gflux)/2) ; NOT icoord=lindgen(41056)	
						glw= gflux[icoord*2l]   > 0    ; Goes Long Wavelength 1.0 - 8.0 Ang
						gsw= gflux[icoord*2l-1] > 0    ; Goes Short Wavelength 0.5 - 4.0 Ang
					ENDIF ELSE BEGIN
						gtime = indgen(24*60*60) ; 86400 elements 0-->86399
		       			glw = replicate(0.0, 24*60*60)
	       				gsw = replicate(0.0, 24*60*60) 	
					ENDELSE
				ENDIF 
	
				IF getGOESLOCALdata THEN BEGIN
					goesfile=goesdir+strmid(date_8digits,0,4)+'/'+goes_spacecraft+date_8digits+'.fits'
									;goesdir e.g. inputdir+'./', goes_spacecraft = 'go15', date_8digits=yyyymmdd
					ext2 = readfits(goesfile, htab, exten_no=2)
					gtime =  tbget( htab, ext2, 'TIME')   ; Goes TIME stamps
					gflux =  tbget( htab, ext2, 'flux')   ; Goes flux levels
					icoord=lindgen(n_elements(gflux)/2)		   ; icoord = lindgen(n_elements(gflux)/2) ; NOT icoord=lindgen(41056)	
					glw= gflux[icoord*2l]   > 0    ; Goes Long Wavelength 1.0 - 8.0 Ang
					gsw= gflux[icoord*2l-1] > 0    ; Goes Short Wavelength 0.5 - 4.0 Ang
				ENDIF
					
	
				; CREATE COMPARED_GOES images
				
				FOR q = q_count, q_count+(n_elements(files_today)-1) DO BEGIN
		
					outdimx=1400   
					outdimy=300
				
					IF not keyword_set(crontab) THEN window, 1, xs=outdimx, ys=outdimy ELSE BEGIN
		      				set_plot, 'Z'
		      				device, set_resolution = [outdimx,outdimy]   ; size of image
		      				device, z_buffering    = 0           ; 0 for 2D
		   			ENDELSE       
		
					; set color table
					device, decomposed=0 
					RED			=indgen(256)
		  			GREEN		=indgen(256)
		 			BLUE 		=indgen(256)
		 			RED[0:5]  	=[0,	0,		0,		255,	255,	255]	      
		 			GREEN[0:5]	=[0,	0,		255,	255,	0,		0]	      
		 			BLUE[0:5] 	=[0,	255,	0,		0,		0,		255]
					; 0=black, 1=blue, 2=green, 3=yellow, 4=red, 5=purple, 255=white
					IF not keyword_set(sol055) THEN BEGIN
						TVLCT,RED,GREEN,BLUE
					ENDIF
					!p.background = 255
				
		
					plot, sec_today,  total(total(regions_today ne 0, 1),1), psym=10, color=0, xrange=[0,(24l*60l*60l)], /xstyle, xminor=1, yrange=[0,5], xmargin=[10,10], ystyle=8, yminor=1, ticklen=0.007, title=date, xtitle='SECONDS IN DAY', ytitle='# MACROPIXELS',charsize=1.3  ; "total" counts amount of locations where regions >0 
																										 ; (does not sum up values of elements regions!)
					plots, [sec_today[q-day_count],sec_today[q-day_count]], [0,5], /data, color=0,  thick=1, linestyle=3
					oplot, gtime, 4*glw/max(glw), psym=10, color=4 ; red
		
					axis, YAXIS=1, YRANGE = ((!Y.CRANGE)*max(glw))/4, YSTYLE=1, yminor=1, ticklen=0.007, YTITLE='GOES x-rays', color=4, charsize=1.3
		
					IF not keyword_set(sol055) THEN BEGIN
						tvlct, rcolor, gcolor, bcolor, /get   
		   			ENDIF
		   			
		   			a=tvrd()			
		   			
		   			IF not keyword_set(sol055) THEN BEGIN
		 				s=size(a)
						image3d_4 = BYTARR(3, s(1), s(2))
		   				image3d_4(0, *, *) = rcolor(a)
		  				image3d_4(1, *, *) = gcolor(a)
		   				image3d_4(2, *, *) = bcolor(a)
		   			ENDIF ELSE BEGIN
		   				s=size(a)
						image3d_4 = BYTARR(3, s(1), s(2))
		   				image3d_4(0, *, *) = RED(a)
		  				image3d_4(1, *, *) = GREEN(a)
		   				image3d_4(2, *, *) = BLUE(a)	
		   			ENDELSE
		   			;for i=2,128 do free_lun, i & write_jpeg, outwwwdir+'EUVflare_'+strmid(strtrim(1000000+q,2),1,6)+'_compared_GOES.jpeg', image3d_4, TRUE=1					
		   			write_jpeg, outwwwdir+'EUVflare_'+strmid(strtrim(1000000+q,2),1,6)+'_compared_GOES.jpeg', image3d_4, TRUE=1		   	
	   	
		   		
		 		;TOWARDS MOVIE 6. (ImageMagick)
		
					spawn, 'convert -size 700x700 xc:white '+outwwwdir+'EUVflare_'+strmid(strtrim(1000000+q,2),1,6)+'_compared_GOES.jpeg '+outwwwdir+'temp_'+strmid(strtrim(1000000+q,2),1,6)+'.jpeg'
					spawn, 'composite -geometry  400x400+150+0 '+outwwwdir+'Thisrun_Win11_'+strmid(strtrim(1000000+q,2),1,6)+'.jpeg '+outwwwdir+'temp_'+strmid(strtrim(1000000+q,2),1,6)+'-0.jpeg '+outwwwdir+'temp_'+strmid(strtrim(1000000+q,2),1,6)+'-0.jpeg'
					spawn, 'composite -geometry  700x150+0+400 '+outwwwdir+'EUVflare_'+strmid(strtrim(1000000+q,2),1,6)+'_compared_GOES.jpeg '+outwwwdir+'temp_'+strmid(strtrim(1000000+q,2),1,6)+'-0.jpeg '+outwwwdir+'temp_'+strmid(strtrim(1000000+q,2),1,6)+'-0.jpeg'   		
				
					q_count = q_count+1
								
				ENDFOR ; for q = q_count, q_count+(n_elements(files_today)-1)
		
				day_count = q_count ; remember last value q_count for loop over q

			ENDIF ; IF nselect_today gt 0 THEN BEGIN ; KB, added 22042013
		
		ENDFOR ; for this_jul = files[0].endjul, files[0].beginjul do begin
	
	ENDIF ; IF n_elements(files) gt 1 THEN BEGIN ; if all images are offpointed and/or blur and/or eclipsed we reduce allfiles to allfiles[0] --> files	
	
	
	; OUTPUT ALL INFO TO sofast_out.html = html page with catalogue events 	 
		
		
	openw, lun6, eventdir+'sofast_out.html', /get_lun, /append 
	printf, lun6, '# EUV FLARE |    date    | start |  end  |   pos    | size | #images | EUV-significance'

	IF max(regions) gt 0 THEN BEGIN
		sofast_readline, savdir+'euvflares.txt', flareslines_orig
		flareslines = reverse(flareslines_orig)
		printf, lun6, flareslines[0:n_elements(flareslines)-1]
	ENDIF ELSE BEGIN
		printf, lun6, '<h3>There are no SoFAST detections for the moment (quiet Sun in EUV or no qualified SWAP data for SoFAST detection)</h3>'
		printf, lun6, '    '
	ENDELSE
	
	IF n_elements(files) gt 1 THEN BEGIN ; if all images are offpointed and/or blur and/or eclipsed we reduce allfiles to allfiles[0] --> files	
		printf, lun6, '<h3>CLICK IMAGE</h3>to see the complete SWAP movie during this run (with indication of detected events)</h3>' 
		printf, lun6, '    '
	ENDIF
	
	printf, lun6, '<h3> '+eclipse_notification+'</h3>' 
	
	; IF not keyword_set(archive) THEN BEGIN
		printf, lun6, '<a href=SoFAST_events_SWAP_'+begindate+'.txt " target="_blank">SoFAST_detections.TXT</a>'
		;printf, lun6, '<a href=SoFAST_events_SWAP_'+begindate+'_compared_to_GOESflarelist.txt " target="_blank">SoFAST_detections_compared_to_GOESflarelist.TXT</a>'	   		   	
	; ENDIF
		   	
	printf, lun6,  '</td>'
	
	IF n_elements(files) gt 1 THEN BEGIN ; if all images are offpointed and/or blur and/or eclipsed we reduce allfiles to allfiles[0] --> files	
		printf, lun6, '<td valign="top"><a href="sofast_ThisRun_Movie.html"><img src="overview_SoFAST_events.png" alt="logo" class="logo" width="400"/></a></td>'
	ENDIF ;ELSE BEGIN
		;printf, lun6, '<td valign="top"><img src="overview_SoFAST_events.png" alt="logo" class="logo" width="400"/></td>'
	;ENDELSE
		    
	printf, lun6, '</PRE>'
	printf, lun6, '</tr>'
	printf, lun6, '</table>'	    
	printf, lun6, '</div>'
	printf, lun6, '</body>'
		    
	printf, lun6, '</html>'  
	close, lun6
	free_lun, lun6
	
	
	; OUTPUT STATISTICAL INFO OF ALL DETECTIONS COMPARED TO GOES to SoFAST_statistical_overview_'+begindate+'.txt 	 	
	
	openw, lun4, eventdir+'SoFAST_statistical_overview_'+begindate+'.txt', /get_lun, width=200, /append ;#DAB
	   
	printf, lun4, ':Issued: '+systime()
	printf, lun4, ':Product: SoFAST catalogue (http://www.sidc.be/sofast)'
	printf, lun4, '#----------------------------------------------------------------------'
	printf, lun4, '# Instrument: SWAP| Detector: CMOS APS 1024 x 1024'
	printf, lun4, '# Flare-threshold : 2 | Rebinsize : 16 | Maxhits : 4 | Offset : 65'
	printf, lun4, '# Modus : (1) SW service <!--(2) Onboard (rebinfirst)-->'
	printf, lun4, '#' 
	printf, lun4, '  first SWAP image this run: '+first_SWAP_thisrun_final
	printf, lun4, '  last  SWAP image this run: '+last_SWAP_thisrun_final
	printf, lun4, '#'   
	printf, lun4, '#' 		
	
	printf, lun4, '   ' ; white line		
	printf, lun4, 'THIS RUN STATISTICAL OVERVIEW'
	printf, lun4, '   ' ; white line
	printf, lun4, '   ' ; white line
	printf, lun4, 'IN GENERAL:'
	printf, lun4, '# SWAP detections this run: ', max(regions)
	printf, lun4, '# GOES detections corresponding this run: ', ngoes_thisrun
	printf, lun4, '# matched GOES events this run: ', n_matched_GOES_events
	printf, lun4, '# missed GOES events this run: ', n_missed_GOES_events
	printf, lun4, 'Max # possible SWAP detections not GOES this run (manually check Event-movies):', max(regions) - n_matched_GOES_events
	printf, lun4, '       (This number does not take into account that different SWAP detections might correspond to the same GOES-flare): '
	printf, lun4, '       Namely the following regions (region, begin-date, begin-time HHMMSS, end-time HHMMSS): '
						
	notgoes=where(detections_not_GOES ne 0, n_detections_not_GOES)
	
	IF n_detections_not_GOES gt 0 THEN BEGIN
		array_detections_not_GOES = detections_not_GOES[notgoes]
			
		FOR m=0, n_detections_not_GOES-1 DO BEGIN
			printf, lun4, array_detections_not_GOES[m], '   ', rbegindate[array_detections_not_GOES[m]-1], '   ', rbegintime[array_detections_not_GOES[m]-1], '   ', rendtime[array_detections_not_GOES[m]-1]
		ENDFOR
	ENDIF ELSE BEGIN
		printf, lun4, '       There are no SWAP detections that are NOT corresponding to GOES flares'
	ENDELSE
			
	printf, lun4, '   ' ; white line
	printf, lun4, 'ABOUT X-flares: ', (float(n_missed_GOES_Xflares)/float(n_X))*100, ' percent missed, ', (float(n_matched_GOES_Xflares)/float(n_X))*100, ' percent detected GOES-X_flares'
	printf, lun4, '# GOES X_flare detections this run: ', n_X
	printf, lun4, '# matched GOES X_flare detections this run: ', n_matched_GOES_Xflares
	printf, lun4, '# missed GOES X_flares this run: ', n_missed_GOES_Xflares
	printf, lun4, '       Namely the following GOES flares (manually check PROBA2-movies): '
	printf, lun4, '       ', str_missed_GOES_Xdetections
			
	printf, lun4, '   ' ; white line
	printf, lun4, 'ABOUT M-flares: ', (float(n_missed_GOES_Mflares)/float(n_M))*100, ' percent missed, ', (float(n_matched_GOES_Mflares)/float(n_M))*100, ' percent detected GOES-M_flares'
	printf, lun4, '# GOES M_flare detections this run: ', n_M
	printf, lun4, '# matched GOES M_flare detections this run: ', n_matched_GOES_Mflares
	printf, lun4, '# missed GOES M_flares this run: ', n_missed_GOES_Mflares
	printf, lun4, '       Namely the following GOES flares (manually check PROBA2-movies): '
	printf, lun4, '       ', str_missed_GOES_Mdetections
						
	printf, lun4, '   ' ; white line
	printf, lun4, 'ABOUT C-flares: ', (float(n_missed_GOES_Cflares)/float(n_C))*100, ' percent missed, ', (float(n_matched_GOES_Cflares)/float(n_C))*100, ' percent detected GOES-C_flares'
	printf, lun4, '# GOES C_flare detections this run: ', n_C
	printf, lun4, '# matched GOES C_flare detections this run: ', n_matched_GOES_Cflares
	printf, lun4, '# missed GOES C_flares this run: ', n_missed_GOES_Cflares
			
	printf, lun4, '   ' ; white line
	printf, lun4, 'ABOUT B-flares: ', (float(n_missed_GOES_Bflares)/float(n_B))*100, ' percent missed, ', (float(n_matched_GOES_Bflares)/float(n_B))*100, ' percent detected GOES-B_flares'
	printf, lun4, '# GOES B_flare detections this run: ', n_B
	printf, lun4, '# matched GOES B_flare detections this run: ', n_matched_GOES_Bflares
	printf, lun4, '# missed GOES B_flares this run: ', n_missed_GOES_Bflares
			
	close, lun4
	free_lun, lun4
	
	
	
	;******************* UNCOMMENTED: CREATE MOVIE 4. eventdir/ThisRun_Win1.mp4 ******************* 
	
	; spawn, 'ffmpeg  -r 3.125 -i '+eventdir+'EUVflare_%03d_Win1.png  -vb 6000000 -pass 1 '+eventdir+'ThisRun_Win1.mp4' 	
	; -vb instead of -b for the video bitrate (-ab for the audio bitrate)
	; COMMAND ABOVE CREATES A MOVIE JUMPING OVER FIRST PRE-EVENT IMAGES (1 per event):
	 		
	;spawn, 'ffmpeg  -r 3.125 -i '+eventdir+'EUVflare_%03d_Win2.png  -vb 6000000 -pass 1 '+eventdir+'ThisRun_Win2.mp4' 	
	; -vb instead of -b for the video bitrate (-ab for the audio bitrate)
	; COMMAND ABOVE CREATES A MOVIE JUMPING OVER LAST DIFF-IMAGES(12min) (1 per event):
	
	; spawn, 'ffmpeg  -r 3.125 -i '+outwwwdir+'Thisrun_Win11_%06d.jpeg  -vb 6000000 -pass 1 '+eventdir+'ThisRun_Win11.mp4' 	
	; -vb instead of -b for the video bitrate (-ab for the audio bitrate)
	; COMMAND ABOVE CREATES A MOVIE OF ALL IMAGES OF THIS RUN (1DAY) INDICATING WHERE EVENTS TAKE PLACE IN TIME.
	
	
	; 	;******************* CREATE MOVIE 5. eventdir/GOES_timeline.mp4 ******************* 
	
	;spawn, 'ffmpeg  -r 3.125 -i '+outwwwdir+'EUVflare_%06d_compared_GOES.jpeg  -vb 6000000 -pass 1 '+eventdir+'GOES_timeline.mp4' 	
	; -vb instead of -b for the video bitrate (-ab for the audio bitrate)
	;; COMMAND ABOVE CREATES A MOVIE OF ALL COMPARED-TO-GOES CURVES OF THIS RUN (1DAY) INDICATING WHERE EVENTS TAKE PLACE IN TIME.
	
	
	 	;******************* CREATE MOVIE 6. eventdir/SoFAST_compared_GOES_timeline.mp4 ******************* 
	IF n_elements(files) gt 1 THEN BEGIN ; if all images are offpointed and/or blur and/or eclipsed we reduce allfiles to allfiles[0] --> files	
		spawn, 'ffmpeg  -r 3.125 -i '+outwwwdir+'temp_%06d-0.jpeg  -vb 6000000 -pass 1 '+eventdir+'SoFAST_compared_GOES_timeline.mp4' 	
		; -vb instead of -b for the video bitrate (-ab for the audio bitrate)
	ENDIF ; if there are no valid images, Thisrun_movie.html will not be loaded from sofast_out.html (neither will overview_SoFAST_events.png appear)

ENDELSE ; IF n_elements(files) le 1 THEN BEGIN .... END ELSE BEGIN

END
